#pragma once

class FontWeightCollection : public std::map<int, CXfFontDef*>
{
public:
/*	CXfFontGlyph* GetGlyph(int unicode, int w, bool bItalic)
	{
		if(find(w) != end())
		{
			CXfFontDef* v = (*this)[w];
			return bItalic ? (v->m_ItalicGlyph.find(unicode) != v->m_ItalicGlyph.end() ? v->m_ItalicGlyph[unicode] : NULL)
				: (v->m_RegularGlyph.find(unicode) != v->m_RegularGlyph.end() ? v->m_RegularGlyph[unicode] : NULL);
		}
		return NULL;
	}*/

	CXfFontDef* GetFontDef(int w) { return find(w) != end() ? (*this)[w] : NULL; }
	void AddFont(int w, CXfFontDef* f) { (*this)[w] = f; }
};

class FontDefMap : public std::map<std::wstring, FontWeightCollection>
{
public:
	bool CheckWeight(std::wstring strName, int w)
	{
		if(find(strName) != end())
		{
			return (*this)[strName].find(w) != (*this)[strName].end();
		}

		return false;
	}

	CXfFontDef* GetFontDef(std::wstring strName, int w)
	{
		if(find(strName) != end())
		{
			FontWeightCollection& fwc = (*this)[strName];
			return fwc.find(w) != fwc.end() ? fwc[w] : NULL;
		}
		return NULL;
	}

	bool AddFont(std::wstring strName, int weight, CXfFontDef* pFontDef)
	{
		FontWeightCollection newCollection;

		if(find(strName) == end())
			(*this)[strName] = newCollection;

		FontWeightCollection& fwc = (*this)[strName];

		if(fwc.find(weight) == fwc.end())
		{
			fwc[weight] = pFontDef;
			return true;
		}
		return false;
	}
};
