#include "stdafx.h"

bool g_bIntelByteOrder = false;

int intel_strcmp(const char* s1, const char* s2)
{
	if(!g_bIntelByteOrder)
		return strcmp(s1, s2);

	size_t iCharCount = strlen(s1);
	char* psz = new char[iCharCount+1];
	psz[iCharCount] = 0;

	for(size_t i = 0; i < iCharCount; i++)
		psz[i] = s1[iCharCount-i-1];

	int iRes = strcmp(psz, s2);
	delete[] psz;
	return iRes;
}

int intel_strncmp(const char* s1, const char* s2, size_t c)
{
	if(!g_bIntelByteOrder)
		return strncmp(s1, s2, c);

	char* psz = new char[c];

	for(int i = 0; i < (int)c; i++)
		psz[i] = s1[c-i-1];

	int iRes = strncmp(psz, s2, c);
	delete[] psz;
	return iRes;
}

DWORD intel_l(DWORD n)
{
	if(g_bIntelByteOrder)
		return n;

	DWORD ans;

	ans  = (n & 0xFF000000) >> 24;
	ans += (n & 0x00FF0000) >> 8;
	ans += (n & 0x0000FF00) << 8;
	ans += (n & 0x000000FF) << 24;
	return (ans);
}

WORD intel_w(WORD n)
{
	if(g_bIntelByteOrder)
		return n;

	WORD ans;

	ans = (WORD) ((n & 0xFF00) >> 8);
	ans = (WORD) (ans + ((n & 0x00FF) << 8));
	return (ans);
}

void intel_w(PSHORT n)
{
	if(g_bIntelByteOrder)
		return;

	short ans;
	ans = (WORD) (((*n) & 0xFF00) >> 8);
	ans = (WORD) (ans + (((*n) & 0x00FF) << 8));
	*n = ans;
}

void intel_wstr(PSHORT strOut, PSHORT strIn, DWORD cnt)
{
	if(g_bIntelByteOrder)
	{
		wcsncpy_s((wchar_t*)strOut, cnt, (wchar_t*)strIn, cnt);
		return;
	}

	for(DWORD i = 0; i < cnt; i++)
		*strOut++ = intel_w(*strIn++);
}

void intel_wstr(PSHORT str)
{
	if(g_bIntelByteOrder)
		return;

	for(;*str != 0;str++)
		intel_w(str);
}

void intel_wstr(PSHORT str, int cnt)
{
	if(g_bIntelByteOrder)
		return;

	for(int i = 0;i < cnt;i++)
	{
		intel_w(str);
		str++;
	}
}

void intel_d(double *dn)
{
	if(g_bIntelByteOrder)
		return;

    double dTemp;
	BYTE  *byTemp;
	BYTE  *bydn;

    bydn  = (BYTE *)dn;
	byTemp= (BYTE *)&dTemp;

    byTemp[0]= bydn[7];
    byTemp[1]= bydn[6];
    byTemp[2]= bydn[5];
    byTemp[3]= bydn[4];
    byTemp[4]= bydn[3];
    byTemp[5]= bydn[2];
    byTemp[6]= bydn[1];
    byTemp[7]= bydn[0];

    *dn= dTemp;
}

void intel_l(PDWORD n)
{
	if(g_bIntelByteOrder)
		return;

	DWORD ans;
	ans  = ((*n) & 0xFF000000) >> 24;
	ans += ((*n) & 0x00FF0000) >> 8;
	ans += ((*n) & 0x0000FF00) << 8;
	ans += ((*n) & 0x000000FF) << 24;
	*n = ans;
}

void intel_w(PWORD n)
{
	if(g_bIntelByteOrder)
		return;

	WORD ans;
	ans = (WORD) (((*n) & 0xFF00) >> 8);
	ans = (WORD) (ans + (((*n) & 0x00FF) << 8));
	*n = ans;
}

short intel_n(PWORD n)
{
	if(g_bIntelByteOrder)
		return (short)*n;

    WORD    ans;
    intel_w(n);
    ans= *n;
    return (short)ans; 
}

void intel_l(PLONG n)
{
	if(g_bIntelByteOrder)
		return;

	long ans;
	ans  = ((*n) & 0xFF000000) >> 24;
	ans += ((*n) & 0x00FF0000) >> 8;
	ans += ((*n) & 0x0000FF00) << 8;
	ans += ((*n) & 0x000000FF) << 24;
	*n = ans;
}
