#pragma once
// maximum number of characters in a ligature - global limit
// increasing this may allow more complex ligatures to be supported, but formatting becomes
// less efficient, and Latin fonts rarely have ligatures of more than 3 characters anyway
#define LIGATURE_MAX_CHARS 3
// maximum size of stylistic sets
#define STYLISTIC_SETS_MAX_SIZE 20

typedef enum LigatureSubsetFlag
{
	LIG_SUB_NONE = 0x01,
	LIG_SUB_STANDARD = 0x02,
	LIG_SUB_HISTORIC = 0x04,
	LIG_SUB_DISCRETIONARY = 0x08,
	LIG_SUB_CONTEXTUAL = 0x10,
	LIG_SUB_ALL = (LIG_SUB_STANDARD | LIG_SUB_HISTORIC | LIG_SUB_DISCRETIONARY | LIG_SUB_CONTEXTUAL)
};

class LigatureEntry
{
public:

	BYTE KeyLth;
	std::wstring Key;
	WCHAR Ligature;
	LigatureSubsetFlag LigType;
	UINT16 Priority;
	DWORD GlyphID;

	LigatureEntry() : Ligature(0), KeyLth(0), LigType(LIG_SUB_NONE),
					  Priority(0), GlyphID(0) {}
};

// initial assumption that stylistic substitution
// won't be greater than ligature
class StylisticSetEntry
{
public:
	WCHAR Key;
	WCHAR StylisticChar;
	DWORD SubGlyphID;

	StylisticSetEntry() : StylisticChar(0), Key(0), SubGlyphID(0) {}
};
