#include "stdafx.h"

#include "XFPathHelpers.h"

/******************************************************************************
   Function:    FindXFPathBounds
   Author:      Paul Gruzdev
   Purpose:		Calc path bounding box given verbs and points pointers
   Returns:     
   Exceptions:  
   Parameters:  
   Notes:       
******************************************************************************/
Rect FindXFPathBounds(const BYTE *pVerb, const DocCoord* pCoord, size_t count)
{
	Rect bounds;
	DocCoord dcLast;
	std::vector<DocCoord> dcBezier;

	for (size_t i = 0; i < count; i++)
	{
		BYTE byVerb = pVerb[i];
		const DocCoord& dc = pCoord[i];

		if(byVerb == PT_MOVETO)
		{
			if(bounds.isNull())
			{
				bounds.x = dc.x;
				bounds.y = dc.y;
			}
			else
				Rect::InflateRectToContainPoint(bounds, dc.x, dc.y);
			dcLast = dc;
		}
		else if(byVerb == PT_BEZIERTO || dcBezier.size() == 2)
		{
			if(dcBezier.size() == 2) // we already stored two control points, adjust our bb
			{
				Rect::inflateRectToContainBezier(bounds, dcLast, dcBezier[0], dcBezier[1], dc);
				dcBezier.clear();
				dcLast = dc;
			}
			else
				dcBezier.push_back(dc);
		}
		else
		{
			Rect::InflateRectToContainPoint(bounds, dc.x, dc.y);
			dcLast = dc;
		}
	}

	return bounds;
}
