#pragma once

class CXfSmartShapeGroup : public CXfGroup
{
public:
	CXfSmartShapeGroup(CXaraFileRecord & rec) : formatVersion(rec), bottomLeft(rec), topRight(rec), strJSON(rec), matrix(rec), strType(rec) {}
	CXfSmartShapeGroup(const CXfSmartShapeGroup& src) : formatVersion(src.formatVersion), bottomLeft(src.bottomLeft), topRight(src.topRight), 
		strJSON(src.strJSON), matrix(src.matrix), strType(src.strType), CXfGroup(src) {}
	CXfSmartShapeGroup(LONG verion, DocCoord bl, DocCoord tr, std::wstring json, XaraMatrix instanceTransform, std::wstring sType) : formatVersion(verion),
		bottomLeft(bl), topRight(tr), strJSON(json), matrix(instanceTransform), strType(sType), CXfGroup(TAG_SMARTSHAPEGROUP) {}

	virtual std::string CreateDumpString();
	virtual VXfTreeNode* Copy() { return new CXfSmartShapeGroup(*this); }

	virtual BOOL Write(CXarExport* pExporter, ULONG* pRecordNum = NULL)
	{
		CXaraFileRecord Rec(TAG_SMARTSHAPEGROUP);
		Rec.Init();
		BOOL ok = formatVersion.Write(&Rec);
		ok = ok && bottomLeft.Write(&Rec);
		ok = ok && topRight.Write(&Rec);
		ok = ok && strJSON.Write(&Rec);
		ok = ok && matrix.Write(&Rec);
		ok = ok && strType.Write(&Rec);
		return ok && pExporter->WriteRecord(&Rec);
	}

	CXfLONG formatVersion;
	CXfDocCoord bottomLeft;
	CXfDocCoord topRight;
	CXfString strJSON;
	CXfMatrix matrix;
	CXfString strType;
};