/* ================================XARAHEADERSTART===========================
 
               PDF2XAR, a PDF file to XAR file converter
                    Copyright (C) 1993-2014 Xara Group Ltd.
       Copyright on certain contributions may be held in joint with their
              respective authors. 


LICENSE TO USE AND MODIFY SOFTWARE
----------------------------------

This file is part of PDF2XAR.

PDF2XAR is free software; you can redistribute it and/or modify it under the 
terms of the GNU General Public License version 2 or version 3 as published
by the Free Software Foundation.

PDF2XAR and its component source files are distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with PDF2XAR (see the file GPL in the root directory of the
distribution); if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

SCOPE OF LICENSE
----------------

This license applies to this program (PDF2XAR) and its constituent source
files only, and does not apply to other Xara products which may
in part share the same code base, and are subject to their own licensing
terms.

This license does not apply to the binary libraries (if any) within
the "libs" directory, which are subject to a separate license contained
within that directory in the file "LIBS-LICENSE".


ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
----------------------------------------------

If you wish to contribute modifications please contact Xara via 
www.xara.com/contact

Please note that Xara will not accept modifications which modify any of
the text between the start and end of this header (marked
XARAHEADERSTART and XARAHEADEREND).

MARKS
-----

Xara, PDF2XAR, Xara Web Designer, Xara Photo & Graphic Designer, Xara Page & 
Layout Designer, Xara Designer Pro and Xara designs are trademarks, design-marks, 
and/or service marks of Xara Group Ltd. All rights in these marks are reserved.


      Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
                        http://www.xara.com/

=================================XARAHEADEREND============================*/
// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#if !defined(AFX_STDAFX_H__CD521C17_74FE_4F79_8190_2912B08ECEF2__INCLUDED_)
#define AFX_STDAFX_H__CD521C17_74FE_4F79_8190_2912B08ECEF2__INCLUDED_
#define _CRT_SECURE_NO_WARNINGS
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers

//#include <afx.h>

#include <windows.h>
#include <atlconv.h>
#include <tchar.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <limits.h>
#include "assert.h"
#include <iostream>
#include <vector>
#include <map>
#include <set>
using namespace std;

// TODO: reference additional headers your program requires here

#define CC_ASSERT_VALID(pOb)  ((void)0)
#define CAM_DEBUG_NEW new

#include <comdef.h>
//#include <comutil.h>

#include "oiltypes.h"

typedef __int64 XLONG ;
typedef unsigned __int64 UXLONG ;

#if _MSC_VER < 1600
extern "C" INT64 __stdcall __emul(LONG,LONG) ;
#endif
#pragma intrinsic(__emul)
#define XMul(A,B) __emul(A,B)
#define XSqr(A)   __emul(A,A)
#define SMul(A,B) (LONG)(__emul(A,B)+0x8000>>16)

// ADDR is a general pointer type. Using void* would mean casts of every use so it is a 
// pointer to BYTE, to make address calculation marginally easier.
typedef BYTE* ADDR;

// This is the correct definition of MILLIPOINT
typedef LONG MILLIPOINT;

// Type for Tags (unique IDs)
typedef ULONG 	TAG;

// This must come after MILLIPOINT as it includes strings.h, which uses millipoints.
#include "handles.h"
#include "ensure.h"
#include "errors.h"
#include "fixst256.h"
#include "ccmaths.h"						// as XMILLIPOINT needs XLONG

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__CD521C17_74FE_4F79_8190_2912B08ECEF2__INCLUDED_)
