/* ================================XARAHEADERSTART===========================
 
               PDF2XAR, a PDF file to XAR file converter
                    Copyright (C) 1993-2014 Xara Group Ltd.
       Copyright on certain contributions may be held in joint with their
              respective authors. 


LICENSE TO USE AND MODIFY SOFTWARE
----------------------------------

This file is part of PDF2XAR.

PDF2XAR is free software; you can redistribute it and/or modify it under the 
terms of the GNU General Public License version 2 or version 3 as published
by the Free Software Foundation.

PDF2XAR and its component source files are distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with PDF2XAR (see the file GPL in the root directory of the
distribution); if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

SCOPE OF LICENSE
----------------

This license applies to this program (PDF2XAR) and its constituent source
files only, and does not apply to other Xara products which may
in part share the same code base, and are subject to their own licensing
terms.

This license does not apply to the binary libraries (if any) within
the "libs" directory, which are subject to a separate license contained
within that directory in the file "LIBS-LICENSE".


ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
----------------------------------------------

If you wish to contribute modifications please contact Xara via 
www.xara.com/contact

Please note that Xara will not accept modifications which modify any of
the text between the start and end of this header (marked
XARAHEADERSTART and XARAHEADEREND).

MARKS
-----

Xara, PDF2XAR, Xara Web Designer, Xara Photo & Graphic Designer, Xara Page & 
Layout Designer, Xara Designer Pro and Xara designs are trademarks, design-marks, 
and/or service marks of Xara Group Ltd. All rights in these marks are reserved.


      Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
                        http://www.xara.com/

=================================XARAHEADEREND============================*/
// $Header: /Camelot/ccinc/awindows.h 14    2/08/96 14:21 Peter $

#ifndef INC_AWINDOWS
#define INC_AWINDOWS

/*
*/

// CC special version of windows.h designed for both Win16 & Win32 compatibility
// For normal C programs, include this instead of windows.h. For MFC C++ programs,
// this has to come after all the afx*.h files.

#ifndef _INC_WINDOWS
#include <windows.h>
#endif
#ifndef RC_INVOKED
#ifndef _INC_WINDOWSX
#include <windowsx.h>
#endif

#if WIN32
#pragma pack(2)
#endif

typedef struct {
	DWORD key;
#if WIN32
	WORD hmf;						// never used as HANDLE
	struct { short left,top,right,bottom; } bbox;
#else
	HANDLE hmf;
	RECT bbox;
#endif
	WORD inch;
	DWORD reserved;
	WORD checksum;
} METAFILEHEADER;

#if WIN32
#pragma pack()
#endif

#define METAFILEHEADERKEY       0x9ac6cdd7L

#ifndef EXPORT
#if WIN32
#define EXPORT
#else
#define EXPORT  __export
#endif
#endif

#ifdef _MSC_VER
// Microsoft specials
#if WIN32
#define	COMPILER_NAME	"Microsoft 32-bit"
#else
#define	COMPILER_NAME	"Microsoft 16-bit"
#endif

#pragma warning(disable:4001)                                           // single line comments

#pragma warning(error:4013 4016 4020 4021 4033 4035 4251)
// cannot do these till c7.1
//#pragma warning(disable:4706)                                         // assignment in if
//#pragma warning(error:4759)                                           // seg lost in conversion
#pragma warning(disable:4090)                                           // consts differ
#endif

#define MAX_FILENAME    260

// extract the lParam from an MDI Create lParam
// (cast to desired type)
#define ExtractMDILong(lp)      (((LPMDICREATESTRUCT) ((LPCREATESTRUCT) lp)->lpCreateParams)->lParam)
	
// Note: this macro assumes offset of zero for the handle entry
#if WIN32
#define SetWindowHandle(hwnd, handle)   SetWindowLong(hwnd, 0, (LONG)handle)
#define GetWindowLHandle(hwnd)                  (LOCALHANDLE)GetWindowLong(hwnd,0)
#else
#define SetWindowHandle(hwnd, handle)   SetWindowWord(hwnd, 0, (WORD)handle)
#define GetWindowLHandle(hwnd)                  (LOCALHANDLE)GetWindowWord(hwnd, 0)
#endif


#define nobreak

// stop warnings on MakeProc/FreeProc
#if !defined(WIN32) && !defined(__WINDOWS_386__)
#define MakeProcInstance(h,p)   MakeProcInstance((FARPROC)(h),(p))
#define FreeProcInstance(p)             FreeProcInstance((FARPROC)(p))
#endif

// cast a common dialog hook proc
typedef UINT (CALLBACK* COMMONDLGHOOK)(HWND,UINT,WPARAM,LPARAM);

// get DebugOutput to work!
#undef  DBF_TRACE
#define DBF_TRACE       DBF_APPLICATION

// some SendMessage macros not in windwsx.h
#if WIN32
#define MDI_SetMenu( hwnd, hframe, hwindow)     SendMessage( (hwnd), WM_MDISETMENU, (WPARAM)(hframe), (LPARAM)(hwindow) )
#define MDI_GetActive(hwnd)     (HWND)SendMessage((hwnd),WM_MDIGETACTIVE,0,0L)
#else
#define MDI_SetMenu( hWnd, hFrame, hWindow)     SendMessage( (hWnd), WM_MDISETMENU, FALSE, MAKELPARAM( (hFrame), (hWindow) ) )
#define MDI_GetActive(hwnd)     (HWND)LOWORD(SendMessage((hwnd),WM_MDIGETACTIVE,0,0L))
#endif
// these are not win32-specific
#define MDI_Create(hwnd, lpMdiCreate)   (HWND)SendMessage((hwnd),WM_MDICREATE,0,(LPARAM)(LPMDICREATESTRUCT)(lpMdiCreate) )
#define MDI_Destroy(hwnd,hchild)        SendMessage((hwnd),WM_MDIDESTROY,(WPARAM)(hchild),0L)
#define MDI_Restore(hwnd, hwnd2)        SendMessage((hwnd),WM_MDIRESTORE,(WPARAM)(hwnd2),0L)
#define QueryEndSession(hwnd)           SendMessage((hwnd),WM_QUERYENDSESSION,0,0L)

// character types in 32-bit windows.h only
#if !defined(WIN32)

// generic character types
typedef char TCHAR;
typedef TCHAR FAR *LPTSTR, FAR *LPTCH, FAR *LPTCHAR, *PTCHAR;
#define TEXT(quote)     quote
#define MAX_PATH        260                     // as in DOS stdlib.h
#define CharUpperChar(z)        (TCHAR)(AnsiUpper( MAKELP(0,(z)) ))

/* Following added by JCF */
typedef const TCHAR FAR* LPCTSTR;

#define CharUpperBuff(x,y)      (DWORD)AnsiUpperBuff((LPSTR)(x),(UINT)(y))
#define CharLowerBuff(x,y)      (DWORD)AnsiLowerBuff((LPSTR)(x),(UINT)(y))

#define CharUpper(x)			(LPTSTR)AnsiUpper((LPSTR)(x))
#define CharLower(x)			(LPTSTR)AnsiLower((LPSTR)(x))

#define CharNext(p)             (LPTSTR)AnsiNext((LPCSTR)(x))
#define CharPrev(s,c)           (LPTSTR)AnsiPrev((LPCSTR)(s),(LPCSTR)(c))

#define PT_CLOSEFIGURE      0x01
#define PT_LINETO           0x02
#define PT_BEZIERTO         0x04
#define PT_MOVETO           0x06

#define CONST const
#define DEVMODE void

#define GdiFlush()

// this proto borrowed fron mstools\h\strct\shellapi.h
int WINAPI ShellAbout(HWND hWnd, LPSTR szApp, LPSTR szOtherStuff, HICON hIcon);

typedef POINT POINTS;
#define MAKEPOINTS      MAKEPOINT

// these are new GetWinFlags() constants
#define WF_CPUR4000                     0x0100
#define WF_CPUALPHA21064        0x0200
#define WF_WINNT                        0x4000

#define OnInitDialogKludge()

#define lstrlenW        lstrlen
#define UNICODE_PAD     1
typedef LPCSTR LPWSTR;

#define APIENTRY far pascal

#ifdef __NOTcplusplus
// make windowsx.h macros C++ friendly
#undef ListBox_SetSel
#undef ListBox_FindString
#define ListBox_SetSel(hwndCtl, fSelect, index)     ((int)(DWORD)::SendMessage((hwndCtl), LB_SETSEL, (WPARAM)(BOOL)(fSelect), MAKELPARAM((index), 0)))
#define ListBox_FindString(hwndCtl, indexStart, lpszFind) ((int)(DWORD)::SendMessage((hwndCtl), LB_FINDSTRING, (WPARAM)(int)(indexStart), (LPARAM)(LPCSTR)(lpszFind)))
#endif

typedef UINT WNETPARAM;

#else

// Win32 missing values (strange but true)
#ifndef __WATCOMC__
typedef TCHAR *LPTCHAR;

#ifndef lstrcpyn
#define lstrcpyn(a,b,c) _tcsncpy(a,b,c)
#endif

#define huge
#else
#undef COMPILER_NAME
#define	COMPILER_NAME	"Watcom 32-bit"
#undef huge
#define huge
#endif

//typedef HANDLE HDROP;                 // until shellapi.h gets updated

//#define       GET_COMMAND_ID(w)       (int)(LOWORD(w))
//#define       GET_COMMAND_CTRL(w,l)   (HWND)(l)
//#define       GET_COMMAND_CODE(w,l)   (UINT)(HIWORD(w))

#define UNICODE_PAD     sizeof(WCHAR)

#ifndef _fmalloc
#define _fmalloc(zz)    malloc(zz)
#define _ffree(zz)              free(zz)
#endif

#define WA_INACTIVE         0
#define WA_ACTIVE           1
#define WA_CLICKACTIVE      2
//#define SetWindowOrg(a,b,c)     SetWindowOrgEx(a,b,c,NULL)
//#define SetWindowExt(a,b,c)     SetWindowExtEx(a,b,c,NULL)
//#define SetViewportOrg(a,b,c)   SetViewportOrgEx(a,b,c,NULL)
//#define SetViewportExt(a,b,c)   SetViewportExtEx(a,b,c,NULL)
//#define MoveTo(a,b,c)                   MoveToEx(a,b,c,NULL)

#define CharUpperChar(z)                (TCHAR)(CharUpper((LPTSTR)(z)))

// Win32s cannot cope with background brushes in dialogs (Oct release)
#define OnInitDialogKludge()    if ((GetVersion()&0x80000000)&&m_hBrushCtlBk) SetCtlBkColor((COLORREF)-1)

#define RUNNING_WIN32S()                (GetVersion()&0x80000000)

// this stops Win-incompatible C runtimes from being declared
// defined automatically on Win16 and Win32-C++
#ifndef _WINDOWS
#define _WINDOWS
#endif

typedef DWORD WNETPARAM;

#endif

#endif

#ifdef __WINDOWS_386__
// Watcom 32-bit Win3.1 specials
// WinMain must be short PASCAL (FAR PASCAL will fail)
// WndProcs must be FAR PASCAL only, no __export (FAR is important)
#undef APIENTRY
#define APIENTRY FAR PASCAL
#undef EXPORT
#define	EXPORT
#define intwinmain      short
#define	COMPILER_NAME	"Watcom 3.1 32-bit"
#else
#define intwinmain      int
#endif

#ifndef	COMPILER_NAME
#define	COMPILER_NAME	"Unknown compiler"
#endif

// RC-only items here:
// borrowed from ddk style.h
#if !defined(WIN32)
#define SS_USERITEM     10L
#endif

#endif
