; ================================XARAHEADERSTART===========================
; 
;                PDF2XAR, a PDF file to XAR file converter
;                     Copyright (C) 1993-2014 Xara Group Ltd.
;        Copyright on certain contributions may be held in joint with their
;               respective authors. 
; 
; 
; LICENSE TO USE AND MODIFY SOFTWARE
; ----------------------------------
; 
; This file is part of PDF2XAR.
; 
; PDF2XAR is free software; you can redistribute it and/or modify it under the 
; terms of the GNU General Public License version 2 or version 3 as published
; by the Free Software Foundation.
; 
; PDF2XAR and its component source files are distributed in the hope
; that it will be useful, but WITHOUT ANY WARRANTY; without even the
; implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; See the GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License along
; with PDF2XAR (see the file GPL in the root directory of the
; distribution); if not, write to the Free Software Foundation, Inc., 51
; Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
; 
; SCOPE OF LICENSE
; ----------------
; 
; This license applies to this program (PDF2XAR) and its constituent source
; files only, and does not apply to other Xara products which may
; in part share the same code base, and are subject to their own licensing
; terms.
; 
; This license does not apply to the binary libraries (if any) within
; the "libs" directory, which are subject to a separate license contained
; within that directory in the file "LIBS-LICENSE".
; 
; 
; ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
; ----------------------------------------------
; 
; If you wish to contribute modifications please contact Xara via 
; www.xara.com/contact
; 
; Please note that Xara will not accept modifications which modify any of
; the text between the start and end of this header (marked
; XARAHEADERSTART and XARAHEADEREND).
; 
; MARKS
; -----
; 
; Xara, PDF2XAR, Xara Web Designer, Xara Photo & Graphic Designer, Xara Page & 
; Layout Designer, Xara Designer Pro and Xara designs are trademarks, design-marks, 
; and/or service marks of Xara Group Ltd. All rights in these marks are reserved.
; 
; 
;       Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
;                         http://www.xara.com/
; 
; =================================XARAHEADEREND============================
; $Header: c:\RCSdir\intel/camasm.inc 1.11 1994/04/08 11:29:47 Jason Exp $

; include file for all Camelot assembly-language.
; BITSIZE should be defined on the command line as 16 or 32

;	IFNDEF	BITSIZE
;	.ERR	BITSIZE not defined
;	ENDIF

; defaults to 16-bit code
;	IFIDN	BITSIZE,16
;BITS	=	16
;	ELSE
BITS	=	32
;	ENDIF


	IF	BITS EQ 16
	.MODEL	LARGE,C
	.386
	ELSE
	.386
	.MODEL	C,FLAT
	ENDIF
	
	.CODE
;	OPTION EMULATOR

; typedefs to make life more readable

;SHORT	TYPEDEF	WORD	not allowed as SHORT is a reserved word (!!arrgg - keyword-ism)
LONG	TYPEDEF DWORD
FIXED16	TYPEDEF DWORD
FIXED24	TYPEDEF	DWORD
LPSTR	TYPEDEF FAR PTR BYTE
DOUBLE	TYPEDEF	REAL8


FIXED_ONE	=	10000h				; 1.0 in fixed-point



; Macros whose meaning depends on compiler size
; accumulator = ax or eax
; CINT is the compiler integer size
; xdi = di or edi
; xsi = si or esi
	IF	BITS EQ 16
accumulator	TEXTEQU	<ax>
xdi	TEXTEQU	<di>
xsi	TEXTEQU	<si>
xcx	TEXTEQU <cx>
CINT	TYPEDEF	WORD		; cannot use INT as that is an opcode!!
	ELSE
accumulator	TEXTEQU	<eax>
xdi	TEXTEQU	<edi>
xsi	TEXTEQU	<esi>
xcx	TEXTEQU <ecx>
CINT	TYPEDEF	DWORD
	ENDIF


; everything that wants to return a long value normally ends up with it in eax.
; Sadly 16-bit compilers expect long results in dx:ax so this macro does just that
; For this to work, the function had better not preserve dx in 16-bit mode

RETURNLONG	MACRO

	IF	BITS EQ 16
	mov	edx,eax
	shr	edx,16
	ENDIF

	ENDM

DECLARE_SOURCE	MACRO	String

MOD_INFO_DATA	SEGMENT	WORD PUBLIC	'FAR_DATA'
	db	String
	db	0
	.CODE

	ENDM


; macro to return FP value
; 16-bit compiler has to return a far pointer to it
; 32-bit compiler just leaves it on the fp stack, which is where it is anyway
RETURNDOUBLE	macro

	IF	BITS EQ 16
	mov	dx,ds
	mov	ax,offset _fac
	fstp	_fac
	ENDIF

	endm


; place marker for opcodes not supported by 8087 emulation under Windows
; just a marker - does nothing. Assumes startup code ensured real co-processor present

NOEMULATION	macro
	endm


; macro to be used in .DATA segment if RETURNDOUBLE is ever used

DECLARE_FPDATA	MACRO

	IF	BITS EQ 16
	EXTERN	_fac:DOUBLE
	ENDIF

	ENDM


; macros to set DS to SS so we can be called from DLL code

	IF	BITS EQ 16

DS_PROLOG	MACRO
	push	ds					; save caller's DS
	push	ss
	pop	ds					; set to callers SS
	ENDM

DS_EPILOG	MACRO
	pop	ds
	ENDM

	ELSE

; 32-bit needs none of that stuff (hoorah!)

DS_PROLOG	MACRO
	ENDM

DS_EPILOG	MACRO
	ENDM

	ENDIF						; bits16

