/* ================================XARAHEADERSTART===========================
 
               PDF2XAR, a PDF file to XAR file converter
                    Copyright (C) 1993-2014 Xara Group Ltd.
       Copyright on certain contributions may be held in joint with their
              respective authors. 


LICENSE TO USE AND MODIFY SOFTWARE
----------------------------------

This file is part of PDF2XAR.

PDF2XAR is free software; you can redistribute it and/or modify it under the 
terms of the GNU General Public License version 2 or version 3 as published
by the Free Software Foundation.

PDF2XAR and its component source files are distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with PDF2XAR (see the file GPL in the root directory of the
distribution); if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

SCOPE OF LICENSE
----------------

This license applies to this program (PDF2XAR) and its constituent source
files only, and does not apply to other Xara products which may
in part share the same code base, and are subject to their own licensing
terms.

This license does not apply to the binary libraries (if any) within
the "libs" directory, which are subject to a separate license contained
within that directory in the file "LIBS-LICENSE".


ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
----------------------------------------------

If you wish to contribute modifications please contact Xara via 
www.xara.com/contact

Please note that Xara will not accept modifications which modify any of
the text between the start and end of this header (marked
XARAHEADERSTART and XARAHEADEREND).

MARKS
-----

Xara, PDF2XAR, Xara Web Designer, Xara Photo & Graphic Designer, Xara Page & 
Layout Designer, Xara Designer Pro and Xara designs are trademarks, design-marks, 
and/or service marks of Xara Group Ltd. All rights in these marks are reserved.


      Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
                        http://www.xara.com/

=================================XARAHEADEREND============================*/
// $Header: /camelot/intel/CCMATHS.H 20    28/11/94 12:45 Alex $

/*
 */ 

// New maths types.

#ifndef INC_CCMATHS
#define INC_CCMATHS

#include "fixed16.h"
#include "fixed24.h"
#include "fixedasm.h"
//#include "fixed32.h"
//#include "ratio.h"

// The following types are same as those defined in classes above.

typedef xlong 	XLONG;		// 64-bit signed value
typedef fixed16 FIXED16;	// 32-bit signed value with binary point between bits 15 and 16.
/*typedef fixed32 FIXED32;	// 64-bit signed value with binary point between bits 31 and 32.
typedef ratio	RATIO;		// 32-bit signed value with binary point between bits 30 and 31. 
*/
typedef fixed16 ANGLE;		// used to represent angles 
typedef XLONG XMILLIPOINT;	// 64-bit coordinate units

// Function Prototypes

BOOL InitMaths();

XLONG Mul(const LONG, const LONG);

XLONG Asl(const LONG, UINT);

XLONG Asr(const LONG, UINT);

LONG MulDiv32By32(const LONG, const LONG, const LONG);
inline fixed16 Div32By32(const LONG a, const LONG b) {fixed16 v;v.all=InternalDiv32by32(a,b);return(v);}
  								
XLONG CCAPI MakeXLong(const LONG);

XLONG CCAPI MakeXLong(const double);

// this value of PI taken from Standard C Library by Plauger
#define	PI	3.14159265358979323846

#endif

