/*
	$Header: /Camelot/winoil/costream_additions.cpp      03/27/05 6:54a DaveR

	costream_additions.cpp

	These additional support methods have been added during the transition from
	<iostream.h> to standard <iostream>
	
*/

#include "stdafx.h"
#include <iostream>
#include <limits.h>
#include <stddef.h>
#include <string.h>
#include "costream.h"

/********************************************************************************************
>	costreambuf::xsgetn( char_type *_Ptr, 
							 streamsize _Count)
							 
	Author:		DaveR
	Created:	3/27/05
	Inputs:		pData						Point to where to place the extracted data
				numElementsToExtract		Number of elements to extract. 

	Purpose:	The protected virtual member function extracts up to _Count elements from 
				the input stream, as if by repeated calls to sbumpc, and stores them in 
				the array beginning at _Ptr. It returns the number of elements actually 
				extracted.
	SeeAlso:	xsputn
********************************************************************************************/

streamsize costreambuf::xsgetn( char_type *pData, streamsize numElementsToExtract)
{
	unsigned long nChar;

	return SUCCEEDED(hr_xsgetn(pData,numElementsToExtract,nChar)) ? nChar : EOF;
}


HRESULT costreambuf::hr_xsgetn(char_type *pData,streamsize numElementsToRead,unsigned long& nChar)
{
	HRESULT hr = m_pIStream->Read(pData, numElementsToRead, &nChar);
	
	return S_OK;

}


