/* ================================XARAHEADERSTART===========================
 
               PDF2XAR, a PDF file to XAR file converter
                    Copyright (C) 1993-2014 Xara Group Ltd.
       Copyright on certain contributions may be held in joint with their
              respective authors. 


LICENSE TO USE AND MODIFY SOFTWARE
----------------------------------

This file is part of PDF2XAR.

PDF2XAR is free software; you can redistribute it and/or modify it under the 
terms of the GNU General Public License version 2 or version 3 as published
by the Free Software Foundation.

PDF2XAR and its component source files are distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with PDF2XAR (see the file GPL in the root directory of the
distribution); if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

SCOPE OF LICENSE
----------------

This license applies to this program (PDF2XAR) and its constituent source
files only, and does not apply to other Xara products which may
in part share the same code base, and are subject to their own licensing
terms.

This license does not apply to the binary libraries (if any) within
the "libs" directory, which are subject to a separate license contained
within that directory in the file "LIBS-LICENSE".


ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
----------------------------------------------

If you wish to contribute modifications please contact Xara via 
www.xara.com/contact

Please note that Xara will not accept modifications which modify any of
the text between the start and end of this header (marked
XARAHEADERSTART and XARAHEADEREND).

MARKS
-----

Xara, PDF2XAR, Xara Web Designer, Xara Photo & Graphic Designer, Xara Page & 
Layout Designer, Xara Designer Pro and Xara designs are trademarks, design-marks, 
and/or service marks of Xara Group Ltd. All rights in these marks are reserved.


      Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
                        http://www.xara.com/

=================================XARAHEADEREND============================*/

// low-level functions for fixed-point arithmetic
// should only be called by fixed16.cpp/fixed32.cpp - everyone else should use ccmaths.h

#ifndef INC_FIX24ASM
#define	INC_FIX24ASM

// requires that fixed24 already be defined


inline LONG Fixed24Mul( fixed24 a, fixed24 b ) { return LONG((__emul((LONG&)a,(LONG&)b)+0x800000)>>24); }

// 1/(1<<24) = 0.000000059604644775390625
inline double Fixed24ToDouble( fixed24 a ) { return (LONG&)a*0.000000059604644775390625; }

#  if defined(_M_IX86) && !defined(_M_X64)
inline LONG Fixed24Div( fixed24 a, fixed24 b ) { static const double s = 16777216.0; LONG t;
												__asm fild a
												__asm fmul s
												__asm fidiv b
												__asm fistp t
												return t; }
inline LONG DoubleToFixed24( double a ) { static const double s = 16777216.0; LONG t;
										  __asm fld a
										  __asm fmul s
										  __asm fistp t
										   return t; }
#elif defined(_M_X64)
inline LONG Fixed24Div( fixed24 a, fixed24 b ) { return _mm_cvtsd_si32( _mm_set_sd((LONG&)a*16777216.0/(LONG&)b) ); }
inline LONG DoubleToFixed24( double a )		   { return _mm_cvtsd_si32( _mm_set_sd(	      a*16777216.0) ); }
#else
inline LONG Fixed24Div( fixed24 a, fixed24 b ) { return MulDiv((LONG&)a,0x1000000,(LONG&)b); }
inline LONG DoubleToFixed24( double a )		   { return floor(a*16777216.0+0.5) ); }
#endif


#endif
