; ================================XARAHEADERSTART===========================
; 
;                PDF2XAR, a PDF file to XAR file converter
;                     Copyright (C) 1993-2014 Xara Group Ltd.
;        Copyright on certain contributions may be held in joint with their
;               respective authors. 
; 
; 
; LICENSE TO USE AND MODIFY SOFTWARE
; ----------------------------------
; 
; This file is part of PDF2XAR.
; 
; PDF2XAR is free software; you can redistribute it and/or modify it under the 
; terms of the GNU General Public License version 2 or version 3 as published
; by the Free Software Foundation.
; 
; PDF2XAR and its component source files are distributed in the hope
; that it will be useful, but WITHOUT ANY WARRANTY; without even the
; implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; See the GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License along
; with PDF2XAR (see the file GPL in the root directory of the
; distribution); if not, write to the Free Software Foundation, Inc., 51
; Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
; 
; SCOPE OF LICENSE
; ----------------
; 
; This license applies to this program (PDF2XAR) and its constituent source
; files only, and does not apply to other Xara products which may
; in part share the same code base, and are subject to their own licensing
; terms.
; 
; This license does not apply to the binary libraries (if any) within
; the "libs" directory, which are subject to a separate license contained
; within that directory in the file "LIBS-LICENSE".
; 
; 
; ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
; ----------------------------------------------
; 
; If you wish to contribute modifications please contact Xara via 
; www.xara.com/contact
; 
; Please note that Xara will not accept modifications which modify any of
; the text between the start and end of this header (marked
; XARAHEADERSTART and XARAHEADEREND).
; 
; MARKS
; -----
; 
; Xara, PDF2XAR, Xara Web Designer, Xara Photo & Graphic Designer, Xara Page & 
; Layout Designer, Xara Designer Pro and Xara designs are trademarks, design-marks, 
; and/or service marks of Xara Group Ltd. All rights in these marks are reserved.
; 
; 
;       Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
;                         http://www.xara.com/
; 
; =================================XARAHEADEREND============================
; $Header: c:\RCSdir\intel/fixedasm.asm 1.33 1994/11/28 12:44:37 Alex Exp $

; fixed-point primitive routines

	IF	0
$Log: fixedasm.asm $
; Revision 1.33  1994/11/28  12:44:37  Alex
; Fixed Div32by32, added fixed16::SetShifted16
; 
; Revision 1.32  1994/11/23  12:17:15  Phil
; Alterations for pixel misalignment problems
; 
; Revision 1.31  1994/10/24  12:44:27  Phil
; Back to previous MPToPixel
; 
; Revision 1.30  1994/10/21  13:33:12  Phil
; New MPToPixel routine
; 
; Revision 1.29  1993/09/24  10:07:46  Andy
; Improved trig comments
; 
; Revision 1.28  1993/09/20  15:02:30  Andy
; Saves ebx in MPToPixel
; 
; Revision 1.27  1993/09/17  19:09:50  Will
; Moved MPtoOS256 into fixedasm.asm
; 
; Revision 1.26  1993/09/15  23:19:26  Will
; Tidied up
; 
; Revision 1.25  1993/09/15  15:31:38  Will
; Changed coords to use Fixed16's for accuracy and speed.
; 
; Revision 1.24  1993/09/07  11:35:00  Andy
; Made LOOP instructions 32-bit aware
; 
; Revision 1.23  1993/09/01  12:17:35  Andy
; Added support for 32-bit assembly
; 
; Revision 1.22  1993/08/12  17:37:58  Andy
; Updated to use more portable fixed16 code
; 
; Revision 1.21  1993/07/16  17:08:15  Andy
; Moved DS_PROLOG into .inc file
; 
; Revision 1.20  1993/07/16  12:10:11  Andy
; Added DS prseveration for export reasons
; 
; Revision 1.19  1993/07/16  11:54:46  Tim
; Added export directive.
; 
; Revision 1.18  1993/07/13  16:43:46  Andy
; Added LongDivFixed16
; 
; Revision 1.17  1993/06/30  17:24:51  Phil
; Added rounding of fractional parts of values before the INTeger
; part is taken (search for "round").
; 
; Revision 1.16  1993/06/10  16:26:49  Andy
; Moved float macros to .inc
; 
; Revision 1.15  1993/06/10  14:29:09  Mario
; added some new comment lines regarding scope
; 
; Revision 1.14  1993/06/03  12:09:39  Andy
; Removed space in DECLARE_SOURCE call
; 
; Revision 1.13  1993/06/03  11:54:48  Andy
; Added DECLARE_SOURCE macro
; 
; Revision 1.12  1993/06/02  14:59:20  Andy
; Fixed include syntax
; 
; Revision 1.11  1993/06/02  14:36:16  Andy
; Uses camasm.h header file
; 
; Revision 1.10  1993/05/31  15:19:08  Andy
; Fixed shrd in 32-bit Fixed16Mul
; 
; Revision 1.9  1993/05/31  13:36:44  Andy
; Fixed MatrixCalc to correct for misunderstanding of
; shld op-code (which turns out to be near useless).
; 
; Revision 1.8  1993/05/27  10:02:08  Andy
; Corrected comment syntax error
; 
; Revision 1.7  1993/05/27  09:59:52  Andy
; Improved comments to match improved ADC
; 
; Revision 1.6  1993/05/14  16:16:17  Andy
; Added LongMulFixed16 and optimised MatricCalc
; 
; Revision 1.5  1993/05/14  15:39:44  Andy
; Added MatrixCalc
; 
; Revision 1.4  1993/05/14  10:52:29  Andy
; Added sin, cos and double conversion fns. Also
; corrected Fixed16ToShort.
; 
; Revision 1.3  1993/05/11  16:14:50  Andy
; Fixed ASCII conversion & added Div32by32 and Neg
; 
; Revision 1.2  1993/05/10  15:08:32  Andy
; Added Mul, Div and ascii conversion
; 
; Revision 1.1  1993/05/07  16:08:59  Andy
; Initial revision
; 

	ENDIF

	INCLUDE	camasm.inc

	OPTION PROC:EXPORT
	
	DECLARE_SOURCE	"$Revision: 1.33 $winoil\fixedasm.asm"

; in order to get the compiler to use a register for return values, instead of a result
; pointer, these fns must be declared extern "C" (MSC v8.00)




	IF	0
/********************************************************************************************

>	FIXED16 Fixed16Mul(FIXED16 arg1, FIXED16 arg2)

	Author: 	Andy
	Created:	10/5/93
	Inputs:		two fixed16s
	Outputs:	None
	Returns:	FIXED16 result (arg1 * arg2)
	Scope:		Only to be used in the FIXED16 class.
	Purpose:	signed multiplication
	Errors:		None (no overflow checks). Rounds

********************************************************************************************/
	ENDIF

Fixed16Mul	PROC arg1:FIXED16, arg2:FIXED16

	mov	eax,arg1
	mov	edx,arg2

	imul	edx

; 64-bit result 12345678.ABCDEFGH
;                 edx   .  eax

; we round by adding 'a half' before we shift
	add	eax,8000h
	adc	edx,0						; 64-bit addition

	IF	BITS EQ 16
; for a 16-bit compiler, we want the result to be:
; ax=ABCD, dx=5678
	shr	eax,16
	ELSE
; for a 32-bit compiler, we want
; eax=5678ABCD
	shrd	eax,edx,16
; Note: trashes edx, but that's OK
	ENDIF

	ret

Fixed16Mul	ENDP



	IF	0
/********************************************************************************************

>	FIXED16 Fixed16Div(FIXED16 arg1, FIXED16 arg2)

	Author: 	Andy
	Created:	10/5/93
	Inputs:		two fixed16s
	Outputs:	None
	Returns:	FIXED16 result (arg1 / arg2)
	Scope:		Only to be used in the FIXED16 class.
	Purpose:	signed division
	Errors:		None (no overflow checks). No rounding either (should it?)
			Overflow will cause a DIV0 exception, as will divide by zero

********************************************************************************************/

This works by taking arg1, multiplying by 65536, then doing a 64-bit/32-bit division
The result will automatically be in the correct format.

	ENDIF

Fixed16Div	PROC	arg1:FIXED16, arg2:FIXED16

; we need to do a 64-bit shift left by 16 which means
; 12345678 goes into
; edx=00001234, eax=56780000

	mov	ax,WORD PTR arg1+2				; high word of arg1
	cwde							; extend sign

	mov	dx,WORD PTR arg1
	shl	edx,16

	xchg	eax,edx						; arrange as edx:eax

	idiv	arg2						; divide by the other arg
								; result in eax
	RETURNLONG

	ret
	
Fixed16Div	ENDP





	IF	0
/********************************************************************************************

>	NOTREALLYAFIXED16 InternalDiv32by32( LONG arg1, LONG arg2 )

	Author: 	Andy
	Created:	11/5/93
	Inputs:		two signed 32-bit numbers
	Outputs:	None
	Returns:	FIXED16 result of arg1/arg2
	Scope:		Private to the CCMATHS library.
	Purpose:	Obtain a fixed-point representation of the ratio between two signed
			numbers.
	Errors:		None. Div0 and overflow will create a div0 exception.

Awooga! Awooga! Do not call this function directly - it returns a long and is meant to be
used only in the C++ wrapper (i.e. it returns the value << 16)

********************************************************************************************/

This is done by multiplying arg1 by 65536, then doing a 64-bit/32-bit division

Curiously enough, this function is 100% the same as Fixed16Div.  When you think about it,
its not really that curious as both args are 65536 times bigger than the FIXED16 versions,
and x/y is identical to x*65536/y*65536.

	ENDIF

InternalDiv32by32	PROC

	jmp	Fixed16Div				; er - wow!

InternalDiv32by32	ENDP




	.DATA

SixtyFourK	LONG	65536
SixtyFourBy180	LONG	65536*180

	DECLARE_FPDATA

	.CODE


; given ST, convert to eax in fixed16 format. Requires FIXED16 temp variable as param
; Important: for 16-bit versions, requires DS=DGROUP

DOUBLETOFIXED	macro	temp
	fild	SixtyFourK
	fmul
	fistp	temp
	endm





	IF	0
/********************************************************************************************

>	double Fixed16ToDouble( FIXED16 arg )

	Author: 	Andy
	Created:	13/5/93
	Inputs:		FIXED16 argument
	Outputs:	None
	Returns:	double-precision value
	Scope:		Only to be used in the FIXED16 class.
	Purpose:	General type conversion
	Errors:		None

********************************************************************************************/

This is done by converting the arg, as a long, into a double, then fp dividing by 65536.
There is undoubtedly a better way, but this works at least.

	ENDIF


Fixed16ToDouble		PROC arg:FIXED16

	DS_PROLOG

	fild	DWORD PTR arg				; push on fpu stack as longword
	fild	SixtyFourK
	fdiv						; arg/65536
	RETURNDOUBLE
	fwait

	DS_EPILOG

	ret

Fixed16ToDouble	ENDP


	IF	0
/********************************************************************************************

>	fixed16 DoubleToFixed16( double arg )

	Author: 	Andy
	Created:	14/5/93
	Inputs:		double-precision argument
	Outputs:	None
	Returns:	FIXED16 value
	Purpose:	General type conversion
	Errors:		None (overflow will cause exception)

********************************************************************************************/

This is done by taking the arg and multiplying it by 65536, then converting to integer.

	ENDIF


DoubleToFixed16		PROC arg:DOUBLE
	LOCAL	result:FIXED16

	DS_PROLOG

	fld	arg				; push arg on fpu stack
	DOUBLETOFIXED	result			;  convert to fixed
	mov	eax,result			; get long result
	RETURNLONG
	fwait

	DS_EPILOG

	ret

DoubleToFixed16	ENDP


	IF	0
/********************************************************************************************

>	FIXED16 Fixed16Sin( FIXED16 arg )

	Author: 	Andy
	Created:	13/5/93
	Inputs:		FIXED16 argument in degrees
	Outputs:	None
	Returns:	FIXED16 result
	Scope:		Only to be used in the FIXED16 class.
	Purpose:	General trigonometry
	Errors:		None

********************************************************************************************/

/********************************************************************************************

>	FIXED16 Fixed16Cos( FIXED16 arg )

	Author: 	Andy
	Created:	13/5/93
	Inputs:		FIXED16 argument in degrees
	Outputs:	None
	Returns:	FIXED16 result
	Scope:		Only to be used in the FIXED16 class.
	Purpose:	General trigonometry
	Errors:		None

********************************************************************************************/

;If n is the input arg in degrees, then from a long it is arg/65536.
In radians, this is arg/65536*pi/180 which is arg*pi/11796480 (=approx 2.66e-7)
The result then needs multiplying by 65536 before returning as a long.

	ENDIF


Fixed16Sin	PROC arg:FIXED16

	LOCAL	result:FIXED16

	DS_PROLOG

	fild	DWORD PTR arg			; push n*65536
	fldpi					; push PI
	fmul					; ST=arg.l*pi
	fild	SixtyFourBy180
	fdiv					;arg*pi/(65536*180)
	fsin					;take the sine
	NOEMULATION
	DOUBLETOFIXED	result
	fwait
	mov	eax,result
	RETURNLONG

	DS_EPILOG

	ret

Fixed16Sin	ENDP

Fixed16Cos	PROC arg:FIXED16

	LOCAL	result:FIXED16

	DS_PROLOG

	fild	DWORD PTR arg			; push n*65536
	fldpi					; push PI
	fmul					; ST=arg.l*pi
	fild	SixtyFourBy180
	fdiv					;arg*pi/(65536*180)
	fcos					;take the cosine
	NOEMULATION
	DOUBLETOFIXED	result
	fwait
	mov	eax,result
	RETURNLONG

	DS_EPILOG

	ret

Fixed16Cos	ENDP



	IF	0
/********************************************************************************************

>	LONG MatrixCalc( FIXED16 fix1, LONG l1, FIXED16 fix2, LONG l2)

	Author: 	Andy
	Created:	14/5/93
	Inputs:		two FIXED16s, two longs
	Outputs:	None
	Returns:	LONG result of fix1*l1 + fix2*l2
	Scope:		Only to be used in the Matrix classes.
	Purpose:	Matrix multiply primitive done using intermediate 64-bit results
			so accuracy is maintained. Special cases are when fix1 or fix2
			are 0.0 or 1.0 as multiplications may be avoided.
			Note that the result is rounded to the nearest integer.
	Errors:		None (overflow ignored).

********************************************************************************************/
	ENDIF

; this macro replaces the brain-damaged shld op-code which only returns the low 32-bits
SHL64	macro	count
	IF	count EQ 1
		add	eax,eax
		adc	edx,edx
	ELSE
		shld edx,eax,count
		shl	 eax,count
	ENDIF
;	LOCAL	doit
;
;	mov	xcx,count
;
;doit:	add	eax,eax
;	rcl	edx,1
;	loop	doit

	endm

;If QUICKMUL is zero then 0.0 and 1.0 optimisations not yet made in order to help debugging.
QUICKMUL	=	1



MatrixCalc	PROC	USES ebx ecx, fix1:FIXED16, l1:LONG, fix2:FIXED16, l2:LONG


	IF	QUICKMUL

	cmp	fix1,0
	jz	fix1_zero
	cmp	fix1,FIXED_ONE
	jnz	@F

; fix1 is 1.0 so 1st intermediate result is l1
	mov	eax,l1
	cdq					; set dx too
	SHL64	16				; *1.0
	jmp	short calc22

; fix1 is 0.0 so no first intermediate result
fix1_zero:
	xor	eax,eax
	xor	edx,edx
	jmp	short calc22			; needed in both ecx:ebx and edx:eax

	ENDIF

; normal 1st calculation

@@:	mov	eax,l1
	imul	fix1				; edx:eax=fix1*l1 (signed)
calc22:	mov	ebx,eax
	mov	ecx,edx				; ecx:ebx=first result

	IF	QUICKMUL

	cmp	fix2,0
	jz	fix2_zero
; if fix2 is 0.0 so 2nd result is ignored - 1st result is OK, result already in edx:eax
	cmp	fix2,FIXED_ONE
	jnz	@F

; fix2 is 1.0 so 2nd result is l2 (sign extended to 64-bits)
	mov	eax,l2
	cdq					; set edx too
	push	cx
	SHL64	16				; *1.0
	pop	cx
	jmp	short final_add

	ENDIF

; normal 2nd calculation

@@:	mov	eax,fix2
	imul	l2				; edx:eax=fix2*l2 (signed)

final_add:
	add	eax,ebx
	adc	edx,ecx				; add two intermediates together

; result is in fixed format, so need shift right by 16 for long result
fix2_zero:
; we round by adding 'a half' before we shift
	add	eax,8000h
	adc	edx,0						; 64-bit addition

	shrd	eax,edx,16

	RETURNLONG

	ret

MatrixCalc	ENDP



	IF	0
/********************************************************************************************

>	LONG LongMulFixed16( LONG arg, FIXED16 fix )

	Author: 	Andy
	Created:	14/5/93
	Inputs:		one FIXED16, one LONG
	Outputs:	None
	Returns:	LONG result of fix * arg
	Scope:		Only to be used in the Matrix class.
	Purpose:	Method of multiplying a long by a fixed point number keeping
			as much accuracy as possible.
	Errors:		None (overflow ignored).

********************************************************************************************/

Very straightforward in assembler. Would be very much harder to do in C without losing
accuracy.

	ENDIF

LongMulFixed16	PROC	arg:LONG, fix:FIXED16

	mov	eax,arg
	imul	fix				;edx:eax = result*65536
	shrd	eax,edx,16			;get back into integer form
	RETURNLONG
	ret

LongMulFixed16	ENDP


	IF	0
/********************************************************************************************

>	LONG LongDivFixed16( LONG arg, FIXED16 fix )

	Author: 	Andy
	Created:	13/7/93
	Inputs:		one FIXED16, one LONG
	Outputs:	None
	Returns:	LONG result of arg / fix
	Purpose:	Method of dividing a long by a fixed point number keeping
			as much accuracy as possible.
	Errors:		None (overflow ignored). Div0 and Overflow will take exception.

********************************************************************************************/
	ENDIF

LongDivFixed16	PROC	USES ecx, arg:LONG, fix:FIXED16

	mov	eax,arg					; get long
	cdq							; into quad
	SHL64	16					; then *1.0 (65536)
	idiv	DWORD PTR fix		; then divide by fixed
	RETURNLONG
	ret

LongDivFixed16	ENDP


	IF	0
/********************************************************************************************

>	LONG MPtoPixel( LONG arg, FIXED16 fix )

	Author: 	Will
	Created:	14/9/93
	Inputs:		one FIXED16, one LONG
	Outputs:	None
	Returns:	LONG result of arg / fix
	Purpose:	Method of dividing a long by a fixed point number keeping
				as much accuracy as possible.
				This version will Round any fractional result to the NEAREST whole value.
				It is used for scaling Millipoints to Whole Pixels.
	Assumptions:Fix is +ve.
	Errors:		None (overflow ignored). Div0 and Overflow will take exception.

********************************************************************************************/
	ENDIF

MPtoPixel	PROC	USES ebx ecx, arg:LONG, fix:FIXED16

	mov	eax,arg				; get long
	cdq						; into quad
	SHL64	16				; then *1.0 (65536)

	mov		ebx, DWORD PTR fix
							; get the divisor
	sar		ebx, 1			; half denominator +ve/-ve
	mov     ecx, 0			; into ebx:ecx - assumption: fix is positive
	cmp		edx, 0 			; look at sign of arg (as we only care about the sign no
							; need for EAX)
	jge		MPTPpositivenumerator
	neg		ebx				; if numerator negative, invert sign
	not		ecx				; always load ffffffff
MPTPpositivenumerator:
	add		eax, ebx		; compensate for truncation so we now round
	adc		edx, ecx		; ... and carry.
	
	idiv	DWORD PTR fix

;	idiv	DWORD PTR fix	; then divide by fixed
;	sar edx, 16             ; Shift remainder
;	
;	mov ebx, fix
;	sar ebx, 17             ; Get Half of divisor
;
;	cmp arg, 0				; Is arg Pos or Neg ?
;	jl RoundDown            ; Round down if neg
;	
;    sub ebx, edx            ; What is the remainder ?
;	adc eax, 0				; Round up if more than a half
;	            
;	jmp SkipIt
;	
;RoundDown:
;	neg edx
;	sub ebx, edx
;	sbb eax, 0              ; Round down if more than a half

SkipIt:
	RETURNLONG
	ret

MPtoPixel ENDP

	IF	0
/********************************************************************************************

>	LONG MPtoOS256( LONG arg, FIXED16 fix )

	Author: 	Will
	Created:	14/9/93
	Inputs:		one FIXED16, one LONG
	Outputs:	None
	Returns:	LONG result of arg / fix
	Purpose:	Method of dividing a long by a fixed point number keeping
				as much accuracy as possible.
				This version will convert the MP value to 256ths of a Pixel.
	Errors:		None (overflow ignored). Div0 and Overflow will take exception.

********************************************************************************************/
	ENDIF

MPtoOS256	PROC	USES ecx, arg:LONG, fix:FIXED16

	sar 	fix, 8          ; Make Result *256

	mov		eax,arg			; get long
	cdq						; into quad
	SHL64	16				; then *1.0 (65536)
	idiv	DWORD PTR fix	; then divide by fixed

	RETURNLONG
	ret

MPtoOS256 ENDP
       
	END

