/* ================================XARAHEADERSTART===========================
 
               PDF2XAR, a PDF file to XAR file converter
                    Copyright (C) 1993-2014 Xara Group Ltd.
       Copyright on certain contributions may be held in joint with their
              respective authors. 


LICENSE TO USE AND MODIFY SOFTWARE
----------------------------------

This file is part of PDF2XAR.

PDF2XAR is free software; you can redistribute it and/or modify it under the 
terms of the GNU General Public License version 2 or version 3 as published
by the Free Software Foundation.

PDF2XAR and its component source files are distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with PDF2XAR (see the file GPL in the root directory of the
distribution); if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

SCOPE OF LICENSE
----------------

This license applies to this program (PDF2XAR) and its constituent source
files only, and does not apply to other Xara products which may
in part share the same code base, and are subject to their own licensing
terms.

This license does not apply to the binary libraries (if any) within
the "libs" directory, which are subject to a separate license contained
within that directory in the file "LIBS-LICENSE".


ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
----------------------------------------------

If you wish to contribute modifications please contact Xara via 
www.xara.com/contact

Please note that Xara will not accept modifications which modify any of
the text between the start and end of this header (marked
XARAHEADERSTART and XARAHEADEREND).

MARKS
-----

Xara, PDF2XAR, Xara Web Designer, Xara Photo & Graphic Designer, Xara Page & 
Layout Designer, Xara Designer Pro and Xara designs are trademarks, design-marks, 
and/or service marks of Xara Group Ltd. All rights in these marks are reserved.


      Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
                        http://www.xara.com/

=================================XARAHEADEREND============================*/

// To handle (non-Unicode) muti-byte character sets, double the width of
// fixed-length character buffers.
#undef	FIX_LEN_BUFSIZE
#ifdef _UNICODE
#define	FIX_LEN_BUFSIZE		(256 + 1)
#else
#define	FIX_LEN_BUFSIZE		((256 + 1) * 2)
#endif

#ifndef INC__FIXSTRING256
#define INC__FIXSTRING256

#include "basestr.h"


/*************************************************************************************
	class String_256 : public StringBase
	
	Author:		JustinF
	Created:	12th August 1993	
	Purpose:	Extends its String base class to become fixed-length and atomically
				allocatable, ie. a failed constructor call for this class will never
				leave the object in an illegal state.
*************************************************************************************/

class String_256 : public StringBase
{
public:
#ifdef _UNICODE
	String_256(const char* psz);
#endif

	String_256(const TCHAR* psz = TEXT(""));
	String_256(const StringBase& other);
//	String_256(UINT resID, UINT hinst = 0);
	String_256(const String_256 &other);
	String_256 & String_256::operator=(const String_256& other);
	virtual ~String_256();

	virtual BOOL Alloc(int nSize);

private:
	TCHAR fixedbuf[FIX_LEN_BUFSIZE];
};




/**************************************************************************************
>	virtual String_256::~String_256()

	Author:		JustinF
	Created:	12th August 1993
	Purpose:	Destroys this fixed-length string.
***************************************************************************************/

inline String_256::~String_256()
{
	// If the string is using the fixed-length buffer then make sure the
	// base class doesn't try to delete[] it.
	if (text == fixedbuf) text = 0;
}

#endif	// INC__FIXSTRING256



////////////////////////////////////////////////////////////////////////////////////////
