/* ================================XARAHEADERSTART===========================
 
               PDF2XAR, a PDF file to XAR file converter
                    Copyright (C) 1993-2014 Xara Group Ltd.
       Copyright on certain contributions may be held in joint with their
              respective authors. 


LICENSE TO USE AND MODIFY SOFTWARE
----------------------------------

This file is part of PDF2XAR.

PDF2XAR is free software; you can redistribute it and/or modify it under the 
terms of the GNU General Public License version 2 or version 3 as published
by the Free Software Foundation.

PDF2XAR and its component source files are distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with PDF2XAR (see the file GPL in the root directory of the
distribution); if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

SCOPE OF LICENSE
----------------

This license applies to this program (PDF2XAR) and its constituent source
files only, and does not apply to other Xara products which may
in part share the same code base, and are subject to their own licensing
terms.

This license does not apply to the binary libraries (if any) within
the "libs" directory, which are subject to a separate license contained
within that directory in the file "LIBS-LICENSE".


ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
----------------------------------------------

If you wish to contribute modifications please contact Xara via 
www.xara.com/contact

Please note that Xara will not accept modifications which modify any of
the text between the start and end of this header (marked
XARAHEADERSTART and XARAHEADEREND).

MARKS
-----

Xara, PDF2XAR, Xara Web Designer, Xara Photo & Graphic Designer, Xara Page & 
Layout Designer, Xara Designer Pro and Xara designs are trademarks, design-marks, 
and/or service marks of Xara Group Ltd. All rights in these marks are reserved.


      Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
                        http://www.xara.com/

=================================XARAHEADEREND============================*/
// $Header: /camelot/winoil/MEMBLK.H 3     5/10/94 14:05 Andy $

// class to handle large memory blocks

#ifndef INC_MEMBLK
#define INC_MEMBLK

// there are two methods we can use: Global(Re)Alloc or VirtualAlloc. Currently we use
// the former under Win16 (& Mac), the latter under Win32s
#if defined(WIN32) && !defined(_MAC)
#define	USE_VM_BLOCKS	1
#else
#define	USE_VM_BLOCKS	0
#endif

enum MemoryBlockType						// this enum is for the type of MemoryBlock
{											// don't add anything in here without asking
	MEMORYBLOCK_HANDLETABLE,   				// Andy
	MEMORYBLOCK_RELOCHEAP,
	MEMORYBLOCK_SCREENBUFFER
};

class MemoryBlock
{
public:


	MemoryBlock();
	~MemoryBlock();

	LPVOID Init( LONG InitSize, BOOL AutoZero, MemoryBlockType );
	void DeInit();
	BOOL Grow( ULONG OldSize, ULONG NewSize, LPVOID *Pointer);
	BOOL Shrink( ULONG OldSize, ULONG NewSize, LPVOID *Pointer);
	#if USE_VM_BLOCKS
	ULONG GetRoundedSize( ULONG RawSize )
	{
		return ( ( (RawSize+PageSize-1) / PageSize ) * PageSize );
	}
	#endif

private:

#if USE_VM_BLOCKS
	LPVOID MemBase;
	ULONG RoundedSize;								// current alloced size, rounded up
	static ULONG PageSize;
#else
	HGLOBAL MemHandle;
	BOOL AutoZero;
#endif

};

#endif
