/* ================================XARAHEADERSTART===========================
 
               PDF2XAR, a PDF file to XAR file converter
                    Copyright (C) 1993-2014 Xara Group Ltd.
       Copyright on certain contributions may be held in joint with their
              respective authors. 


LICENSE TO USE AND MODIFY SOFTWARE
----------------------------------

This file is part of PDF2XAR.

PDF2XAR is free software; you can redistribute it and/or modify it under the 
terms of the GNU General Public License version 2 or version 3 as published
by the Free Software Foundation.

PDF2XAR and its component source files are distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with PDF2XAR (see the file GPL in the root directory of the
distribution); if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

SCOPE OF LICENSE
----------------

This license applies to this program (PDF2XAR) and its constituent source
files only, and does not apply to other Xara products which may
in part share the same code base, and are subject to their own licensing
terms.

This license does not apply to the binary libraries (if any) within
the "libs" directory, which are subject to a separate license contained
within that directory in the file "LIBS-LICENSE".


ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
----------------------------------------------

If you wish to contribute modifications please contact Xara via 
www.xara.com/contact

Please note that Xara will not accept modifications which modify any of
the text between the start and end of this header (marked
XARAHEADERSTART and XARAHEADEREND).

MARKS
-----

Xara, PDF2XAR, Xara Web Designer, Xara Photo & Graphic Designer, Xara Page & 
Layout Designer, Xara Designer Pro and Xara designs are trademarks, design-marks, 
and/or service marks of Xara Group Ltd. All rights in these marks are reserved.


      Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
                        http://www.xara.com/

=================================XARAHEADEREND============================*/
// $Header: /Camelot/intel/oiltypes.h 20    15/10/99 12:56 Justinf $

#ifndef INC_OILTYPES
#define INC_OILTYPES

// This file includes the required system headers and defines types whose definitions
// are machine-dependent. It should also include other machine-specific header files.

#if WIN32
  #define	STRICT	1
#else
  #define	STRICT
#endif

#undef	_WIN32_IE
#define	_WIN32_IE	0x0400

#define OEMRESOURCE			// required for access to the display driver's bitmaps

#include "awindows.h"

#if FALSE

#include <afxwin.h>			// 'standard' libraries & AFX
#include <stdlib.h>

#include <afxcmn.h>
#include <afxext.h> 		// MFC extensions (including VB)

// if _OLE_VER is defined, leave it alone, else default it based on the MFC version
#ifndef _OLE_VER
	#if (_MFC_VER >= 0x250)				// MFC 2.5 and above supports OLE 2.0, while		
		#define _OLE_VER 0x200
	#else						// MFC 2.0 supports only OLE 1.0
	  #define _OLE_VER 0x100
	#endif
#endif

#if _OLE_VER > 0
#include <afxole.h>			// MFC OLE support (unless OLE_VER is zero)
#endif

#if (_OLE_VER >= 0x200)
  #include <afxodlgs.h>
  #include <afxdisp.h>
#endif

#endif	// FALSE

typedef unsigned long ULONG;

// min and max macros
#define max(a,b)  (((a) > (b)) ? (a) : (b))
#define min(a,b)  (((a) < (b)) ? (a) : (b))
#define Abs(a)  (((a) < 0) ? (-(a)) : (a))
#ifndef ABS
#define ABS(a) ( ((a) < 0) ? -(a) : (a) )
#endif

// Win32 doesn't need any source changes - its done by the linker
#define CAMAPI
#define CCAPI

#ifdef _DEBUG
  BOOL CCAPI IsUserName(const char *wanted);
#else
  #define	IsUserName(name)	FALSE
#endif

typedef __int64 xlong;

#define THIS_FILE __FILE__

#ifdef _DEBUG

void CamTrace(const char *lpszFormat, ...);
void CamTrace(const wchar_t *lpszFormat, ...);
#define TRACE              ::CamTrace

#else

inline void CamTrace(const char *, ...) { }
inline void CamTrace(const wchar_t *, ...) { }
#define TRACE              1 ? (void)0 : ::CamTrace

#endif	// _DEBUG

#define nobreak		// extension for the C case statement
#define OVERRIDE override
#define FINAL final
#define UNREFERENCED_LOCAL_VARIABLE(V)	(void)(V)

#endif	// INC_OILTYPES
