; ================================XARAHEADERSTART===========================
; 
;                PDF2XAR, a PDF file to XAR file converter
;                     Copyright (C) 1993-2014 Xara Group Ltd.
;        Copyright on certain contributions may be held in joint with their
;               respective authors. 
; 
; 
; LICENSE TO USE AND MODIFY SOFTWARE
; ----------------------------------
; 
; This file is part of PDF2XAR.
; 
; PDF2XAR is free software; you can redistribute it and/or modify it under the 
; terms of the GNU General Public License version 2 or version 3 as published
; by the Free Software Foundation.
; 
; PDF2XAR and its component source files are distributed in the hope
; that it will be useful, but WITHOUT ANY WARRANTY; without even the
; implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; See the GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License along
; with PDF2XAR (see the file GPL in the root directory of the
; distribution); if not, write to the Free Software Foundation, Inc., 51
; Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
; 
; SCOPE OF LICENSE
; ----------------
; 
; This license applies to this program (PDF2XAR) and its constituent source
; files only, and does not apply to other Xara products which may
; in part share the same code base, and are subject to their own licensing
; terms.
; 
; This license does not apply to the binary libraries (if any) within
; the "libs" directory, which are subject to a separate license contained
; within that directory in the file "LIBS-LICENSE".
; 
; 
; ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
; ----------------------------------------------
; 
; If you wish to contribute modifications please contact Xara via 
; www.xara.com/contact
; 
; Please note that Xara will not accept modifications which modify any of
; the text between the start and end of this header (marked
; XARAHEADERSTART and XARAHEADEREND).
; 
; MARKS
; -----
; 
; Xara, PDF2XAR, Xara Web Designer, Xara Photo & Graphic Designer, Xara Page & 
; Layout Designer, Xara Designer Pro and Xara designs are trademarks, design-marks, 
; and/or service marks of Xara Group Ltd. All rights in these marks are reserved.
; 
; 
;       Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
;                         http://www.xara.com/
; 
; =================================XARAHEADEREND============================
; $Header: c:\RCSdir\intel/xlongasm.asm 1.27 1994/01/25 18:05:11 Andy Exp $

; 64-bit integer primitives

	IF	0
; $Log: xlongasm.asm $
; Revision 1.27  1994/01/25  18:05:11  Andy
; Fixed Xlongbyfixed16one to work properly
; 
; Revision 1.26  1993/09/07  17:25:39  Andy
; XlongToLong 32-bit works
; 
; Revision 1.25  1993/09/07  11:34:54  Andy
; Made LOOP instructions 32-bit aware
; 
; Revision 1.24  1993/09/01  12:17:28  Andy
; Added support for 32-bit assembly
; 
; Revision 1.23  1993/08/23  17:03:27  JustinF
; Reduced dependencies on the String header file & rewrite ToString()
; 
; Revision 1.22  1993/07/16  17:08:28  Andy
; Added DS_PROLOG
; 
; Revision 1.21  1993/07/16  11:54:31  Tim
; Added export directive.
; 
; Revision 1.20  1993/07/13  14:03:53  Phil
; Andy fixed the rounding of the result of XMatrixCalc
; so that the carry gets propagated OK.
; 
; Revision 1.19  1993/06/30  17:23:39  Phil
; Added rounding of fractional parts of values before the INTeger
; part is taken (search for "round").
; 
; Revision 1.18  1993/06/11  16:39:01  Mario
; Tidied up comments
; 
; Revision 1.17  1993/06/10  16:27:11  Andy
; Added Xlong<->Double conversions
; 
; Revision 1.16  1993/06/03  12:06:24  Andy
; Added DECLARE_SOURCE macro
; 
; Revision 1.15  1993/06/02  14:59:22  Andy
; Fixed include syntax
; 
; Revision 1.14  1993/06/02  14:36:14  Andy
; Uses camasm.h header file
; 
; Revision 1.13  1993/05/31  15:20:01  Andy
; Changed XMatrixCalc to use references
; 
; Revision 1.12  1993/05/30  15:31:43  Andy
; Changed XMatrixCalc params
; 
; Revision 1.11  1993/05/30  12:35:56  Andy
; Added XlongByFixed16One
; 
; Revision 1.10  1993/05/18  11:45:25  Andy
; Corrected mulitply-declared comments by inserting a blank
; line between functions
; 
; Revision 1.9  1993/05/10  12:20:07  Andy
; Fixed MulHuge so that one arg negative works
; 
; Revision 1.8  1993/05/06  17:26:47  Andy
; added XlongToAscii/Unicode
; 

	ENDIF

	INCLUDE	camasm.inc

	OPTION PROC:EXPORT

	DECLARE_SOURCE	"$Revision: 1.27 $winoil\xlongasm.asm"

	.DATA

	DECLARE_FPDATA

	.CODE


;	Xlong is assumed to be in Intel-quad word order i.e. the first long is the
;	least significant
;	These functions are private to the xlong class - no-one else should call them


;	These functions only trash these registers:
;	eax		used as return value
;	es		used in segmented code
;	This should mean that it complies with all calling conventions




; negate a 64-bit register pair
; also sets carry flag to suitable value for >64bit negation

Neg64	MACRO	hireg,lowreg,scratch

	mov	scratch,hireg
	xor	hireg,hireg
	neg	lowreg
	sbb	hireg,scratch

	ENDM



	COMMENT	@
/********************************************************************************************

>	void XlongAdd(XLONG *input1, XLONG *input2, XLONG *result)

>	void XlongAddOne(xlong *input1, xlong *result)

	Author: 	Andy
	Created:	27/4/93
	Scope:		Private to XLONG class
	Inputs:
	Outputs:	pointer to the xlong result
	Returns:	None
	Purpose:	64-bit signed addition
	Errors:		None (no overflow checks)

********************************************************************************************/
@

	IF	BITS EQ 16

XlongAdd	PROC USES edx di, input1:DWORD, input2:DWORD, result:DWORD

	les	di,input1

	mov	eax,DWORD PTR es:[di]
	mov	edx,DWORD PTR es:[di+4]

	les	di,input2

	add	eax,DWORD PTR es:[di]
	adc	edx,DWORD PTR es:[di+4]

	les	di,result

	mov	DWORD PTR es:[di],eax
	mov	DWORD PTR es:[di+4],edx

	ret

XLongAdd	ENDP

	ELSE

; 32-bit version
XlongAdd	PROC USES edi edx, input1:DWORD, input2:DWORD, result:DWORD

	mov	edi,input1

	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,input2

	add	eax,[edi]
	adc	edx,[edi+4]

	mov	edi,result

	mov	[edi],eax
	mov	[edi+4],edx

	ret

XlongAdd	ENDP

	ENDIF


	IF	BITS EQ 16

XlongAddOne	PROC USES edx di, input:DWORD, result:DWORD

	les	di,input

	mov	eax,DWORD PTR es:[di]
	mov	edx,DWORD PTR es:[di+4]

	les	di,result

	add	DWORD PTR es:[di],eax
	adc	DWORD PTR es:[di+4],edx

	ret

XLongAddOne	ENDP

	ELSE

XlongAddOne	PROC USES edx edi, input:DWORD, result:DWORD

	mov	edi,input

	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,result

	add	[edi],eax
	adc	[edi+4],edx

	ret

XLongAddOne	ENDP

	ENDIF


	COMMENT	@
/********************************************************************************************

>	void XlongSub(XLONG *input1, XLONG *input2, XLONG *result)

>	void XlongSubOne(xxlong *input, xlong *result)

	Author: 	Andy
	Created:	27/4/93
	Scope:		Private to XLONG class
	Inputs:
	Outputs:	pointer to the xlong result (input1 - input2) or (result-=input)
	Returns:	None
	Purpose:	64-bit signed subtraction
	Errors:		None (no overflow checks)

	Most of the overhead is in extracting the parameters from the pointers
	so this does *not* use macros to hide memory models etc
********************************************************************************************/
@

	IF	BITS EQ 16

XlongSub	PROC USES edx di, input1:DWORD, input2:DWORD, result:DWORD

	les	di,input1

	mov	eax,DWORD PTR es:[di]
	mov	edx,DWORD PTR es:[di+4]

	les	di,input2

	sub	eax,DWORD PTR es:[di]
	sbb	edx,DWORD PTR es:[di+4]

	les	di,result

	mov	DWORD PTR es:[di],eax
	mov	DWORD PTR es:[di+4],edx

	ret

XLongSub	ENDP

	ELSE

XlongSub	PROC USES edx edi, input1:DWORD, input2:DWORD, result:DWORD

	mov	edi,input1

	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,input2

	sub	eax,[edi]
	sbb	edx,[edi+4]

	mov	edi,result

	mov	[edi],eax
	mov	[edi+4],edx

	ret

XLongSub	ENDP

	ENDIF


	IF	BITS EQ 16

XlongSubOne	PROC USES edx di, input:DWORD, result:DWORD

	les	di,input

	mov	eax,DWORD PTR es:[di]
	mov	edx,DWORD PTR es:[di+4]

	les	di,result

	sub	DWORD PTR es:[di],eax
	sbb	DWORD PTR es:[di+4],edx

	ret

XLongSubOne	ENDP

	ELSE

XlongSubOne	PROC USES edx edi, input:DWORD, result:DWORD

	mov	edi,input

	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,result

	sub	[edi],eax
	sbb	[edi+4],edx

	ret

XLongSubOne	ENDP

	ENDIF


	COMMENT	@
/********************************************************************************************

>	extern "C" void XlongNegOne(XLONG *arg)

	Author: 	Andy
	Created:	27/4/93
	Scope:		Private to XLONG class
	Inputs:		pointer to value requiring negation
	Outputs:	contents of pointer pointer updated
	Returns:	None
	Purpose:	64-bit signed negation
	Errors:		None (no overflow checks)

********************************************************************************************/
@

; todo: check the special case of negating 0x800000..00

	IF	BITS EQ 16

XlongNegOne	PROC USES edx di esi, arg:DWORD

	les	di,arg

	mov	eax,es:[di]
	mov	edx,es:[di+4]

	Neg64	edx,eax,esi

	mov	DWORD PTR es:[di],eax
	mov	DWORD PTR es:[di+4],edx

	ret

XLongNegOne	ENDP

	ELSE

XlongNegOne	PROC USES edx edi esi, arg:DWORD

	mov	edi,arg

	mov	eax,[edi]
	mov	edx,[edi+4]

	Neg64	edx,eax,esi

	mov	[edi],eax
	mov	[edi+4],edx

	ret

XLongNegOne	ENDP

	ENDIF


	COMMENT	@
/********************************************************************************************

>	LONG Mul32Div32(LONG mul1, LONG mul2, LONG divisor)

	Author: 	Andy
	Created:	28/4/93
	Scope:		Private to XLONG class
	Inputs:		two multiplicands, one divisor
	Outputs:	result of mul1*mul2/div using 64-bit intermediate result (signed)
	Returns:	LONG result
	Purpose:	To avoid losing precision 
	Errors:		If divisor zero or overflow will INT 0 (div0)

********************************************************************************************/
@

	IF	BITS EQ 16
Mul32Div32	PROC mul1:DWORD, mul2:DWORD, divisor:DWORD
	ELSE
Mul32Div32	PROC USES edx, mul1:DWORD, mul2:DWORD, divisor:DWORD
	ENDIF

	mov	eax,mul1
	imul	mul2			; 64-bit result in EDX:EAX
	idiv	divisor			; eax=result, edx=remainder (lost)

	ReturnLong

	ret

Mul32Div32	ENDP


	COMMENT	@
/********************************************************************************************

>	void XMul32(LONG mul1, LONG mul2, XLONG& result)

	Author: 	Andy
	Created:	28/4/93
	Scope:		Private to XLONG class
	Inputs:		two 32-bit multiplicands
	Outputs:	signed 64-bit
	Returns:	none
	Purpose:	To avoid losing precision 
	Errors:		None (no overflow checks)

********************************************************************************************/
@

XMul32	PROC USES edi edx, mul1:DWORD, mul2:DWORD, result:DWORD

	mov	eax,mul1
	imul	mul2

	IF	BITS EQ 16
	les	di,result
	mov	DWORD PTR es:[di],eax
	mov	DWORD PTR es:[di+4],edx
	ELSE
	mov	edi,result
	mov	[edi],eax
	mov	[edi+4],edx
	ENDIF

	ret

XMul32	ENDP


	COMMENT @
/********************************************************************************************

	PRIVATE	MulHuge

	Author: 	Andy
	Created:	28/4/93
	Inputs:		two 64-bit signed multiplicands: edx:eax and ecx:ebx
	Outputs:	ecx:ebx:edx:eax.
	Returns:	128-bit signed result
	Purpose:	Private to this file. Used by other mult functions.
	Errors:		None (cannot overflow)

********************************************************************************************/

	The algorithm is based on the equation (ax+b)*(cx+d) = acxx + (bc+ad)x + bd
	where x=1^32. This lets us do a 64-bit multiply based on a 32x32 multiply
	primitive. To match the register names, this converts to
		dcxx + (ac+db)x + ab

	Firstly a check is made for both args being 32-bit signed numbers. If they are
	then only one IMUL op is required.

	Secondly both args are made positive and the final output sign saved for
	correction after the calculation is complete.
@




MulHuge	PROC NEAR USES esi edi PRIVATE
	LOCAL result[4]:DWORD, sign:BYTE

; RSN special case when both are really signed 32-bit numbers
; this isn't done yet so that bugs in this code may be found more easily



; make both numbers positive and remember output sign
; this means all internal calcs can be done using unsigned values


	mov	sign,0
	or	edx,edx
	jns	@F

	inc	sign
	Neg64	edx,eax,esi
@@:
	or	ecx,ecx
	jns	@F

	xor	sign,1
	Neg64	ecx,ebx,esi
@@:

	mov	edi,eax				;edi = input a
	mov	esi,edx				;esi = input d

	mul	ebx				;done ab
	mov	result+3*4,eax
	mov	result+2*4,edx			;store ab

	mov	eax,edi				;a
	mul	ecx				;a*c
	add	result+2*4,eax
	adc	edx,0
	mov	result+1*4,edx			;add in acx

	mov	eax,esi				;d
	mul	ebx				;d*b
	add	result+2*4,eax
	mov	eax,0				;leaves carry flag alone
	adc	result+1*4,edx			;add in dbx
	adc	al,0
	mov	result+0*4,eax

	mov	eax,ecx				;c
	mul	esi				;c*d
	add	result+1*4,eax
	adc	result+0*4,edx			;add in dcxx

	mov	ecx,result+0*4			;(inefficient use of result[0])
	mov	ebx,result+1*4
	mov	edx,result+2*4
	mov	eax,result+3*4

; put sign back
	cmp	sign,0
	jz	@F

; now we have to do a 128-bit negation (!)
	Neg64	edx,eax,esi			; do low 64-bits
	mov	esi,0				; keep carry flag
	sbb	esi,ebx
	mov	ebx,esi
	mov	esi,0
	sbb	esi,ecx
	mov	ecx,esi

@@:

	ret

MulHuge	ENDP





	COMMENT	@
/********************************************************************************************

>	void XMul64( const XLONG& m1,const XLONG& m2, XLONG& result)

>	void XMul64One(const XLONG& m, XLONG& result)

	Author: 	Andy
	Created:	28/4/93
	Scope:		Private to XLONG class
	Inputs:		two 64-bit multiplicands
	Outputs:	signed 64-bit (m1*m2 or result*=m)
	Returns:	none
	Purpose:	Private to ccmath.h. Primitive for operator overloading
	Errors:		None (no overflow checks)

********************************************************************************************/
@

	IF	BITS EQ 16

XMul64	PROC USES di ebx ecx edx, m1:DWORD, m2:DWORD, result:DWORD

	les	di,m1
	mov	eax,es:[di]
	mov	edx,es:[di+4]

	les	di,m2
	mov	ebx,es:[di]
	mov	ecx,es:[di+4]

	call	MulHuge

	les	di,result
	mov	es:[di],eax
	mov	es:[di+4],edx				; throws top 64-bits away

	ret

XMul64	ENDP


XMul64One	PROC USES di ebx ecx edx, m:DWORD, result:DWORD

	les	di,m
	mov	eax,es:[di]
	mov	edx,es:[di+4]

	les	di,result
	mov	ebx,es:[di]
	mov	ecx,es:[di+4]

	call	MulHuge					; does not trash es:di

	mov	es:[di],eax
	mov	es:[di+4],edx				; throws top 64-bits away

	ret

XMul64One	ENDP

	ELSE

; 32-bit
XMul64	PROC USES edi ebx ecx edx, m1:DWORD, m2:DWORD, result:DWORD

	mov	edi,m1
	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,m2
	mov	ebx,[edi]
	mov	ecx,[edi+4]

	call	MulHuge

	mov	edi,result
	mov	[edi],eax
	mov	[edi+4],edx				; throws top 64-bits away

	ret

XMul64	ENDP

;32-bit
XMul64One	PROC USES edi ebx ecx edx, m:DWORD, result:DWORD

	mov	edi,m
	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,result
	mov	ebx,[edi]
	mov	ecx,[edi+4]

	call	MulHuge					; does not trash edi

	mov	[edi],eax
	mov	[edi+4],edx				; throws top 64-bits away

	ret

XMul64One	ENDP

	ENDIF

	COMMENT	@
/********************************************************************************************

>	void LongToXlong( const LONG input, xlong& result)

	Author: 	Andy
	Created:	29/4/93
	Scope:		Private to XLONG class
	Inputs:		32-bit signed long
	Outputs:	64-bit signed xlong
	Returns:	none
	Purpose:	Private to ccmath.h. Primitive for operator overloading
	Errors:		None possible

********************************************************************************************/
@

LongToXlong	PROC USES edi edx, input:DWORD, result:DWORD

	mov	eax,input
	cdq						; sign extend into edx

	IF	BITS EQ 16
	les	di,result
	mov	es:[di],eax
	mov	es:[di+4],edx
	ELSE
	mov	edi,result
	mov	[edi],eax
	mov	[edi+4],edx
	ENDIF

	ret

LongToXlong	ENDP




	COMMENT	@
/********************************************************************************************

>	LONG XlongToLong( const xlong& input)

	Author: 	Andy
	Created:	29/4/93
	Scope:		Private to XLONG class
	Inputs:		64-bit signed xlong
	Outputs:	32-bit signed long
	Returns:	none
	Purpose:	Private to ccmath.cpp. Primitive for operator overloading
	Errors:		None (overflow ignored)

********************************************************************************************/
@

XlongToLong	PROC USES xdi, input:DWORD

	IF	BITS EQ 16
	les	di,input
	mov	eax,es:[di]				; simply throw away top 32-bits
	ELSE
	mov	edi,input
	mov	eax,[edi]
	ENDIF
	ReturnLong

	ret

XlongToLong	ENDP
	

;-------------------------------------------------------------------------------------------
;	Macro to shift edx:eax left by cx
;-------------------------------------------------------------------------------------------

;	Note that the 64-bit shift instruction only gives 32-bit results so cannot be used
;	As a result we have to do it the slow way, a bit at a time

BIGASL	MACRO
	LOCAL	done

	and	xcx,3Fh
	jz	done					; shifts of 0 are v. quick

; todo: optimise if only really a 32-bit value

@@:	sal	eax,1					; shift low32, top bit into carry
	rcl	edx,1					; shift high32, carry into bit 0
	loop	@B					; do all those shifts
done:
	ENDM


	COMMENT	@
/********************************************************************************************

>	void XlongAsl64( const xlong& input, int shift, xlong& result)

>	void XlongAsl64One( int shift, xlong& result)

	Author: 	Andy
	Created:	29/4/93
	Scope:		Private to XLONG class
	Inputs:		64-bit signed xlong, int shift count
	Outputs:	64-bit signed xlong
	Returns:	none
	Purpose:	Private to ccmath.cpp. Primitive for operator overloading
	Errors:		None (overflow ignored). The shift count is masked with 3F
			for compatibility with normal Intel shifts

********************************************************************************************/
@

	IF	BITS EQ 16

XlongAsl64	PROC USES di cx edx, input:DWORD, count:WORD, result:DWORD

	les	di,input
	mov	eax,es:[di]
	mov	edx,es:[di+4]
	mov	cx,count

	BIGASL

	les	di,result
	mov	es:[di],eax
	mov	es:[di+4],edx
	ret

XlongAsl64	ENDP


XlongAsl64One	PROC USES di cx edx, count:WORD, result:DWORD

	les	di,result
	mov	eax,es:[di]
	mov	edx,es:[di+4]
	mov	cx,count
	BIGASL
	mov	es:[di],eax
	mov	es:[di+4],edx
	ret

XlongAsl64One	ENDP

	ELSE

;32-bit
XlongAsl64	PROC USES edi ecx edx, input:DWORD, count:CINT, result:DWORD

	mov	edi,input
	mov	eax,[edi]
	mov	edx,[edi+4]
	mov	ecx,count

	BIGASL

	mov	edi,result
	mov	[edi],eax
	mov	[edi+4],edx
	ret

XlongAsl64	ENDP

;32-bit
XlongAsl64One	PROC USES edi ecx edx, count:CINT, result:DWORD

	mov	edi,result
	mov	eax,[edi]
	mov	edx,[edi+4]
	mov	ecx,count
	BIGASL
	mov	[edi],eax
	mov	[edi+4],edx
	ret

XlongAsl64One	ENDP

	ENDIF

;-------------------------------------------------------------------------------------------
;	Macro to shift edx:eax right by cx
;-------------------------------------------------------------------------------------------

;	Note that the 64-bit shift instruction only gives 32-bit results so cannot be used
;	As a result we have to do it the slow way, a bit at a time

BIGSAR	MACRO
	LOCAL	done

	and	xcx,3Fh
	jz	done					; shifts of 0 are v. quick

; todo: optimise if only really a 32-bit value

@@:	sar	edx,1					; shift top32, top bit left alone
							; low bit goes into carry
	rcr	eax,1					; shift low32, puts carry in bit31
	loop	@B					; do all those shifts

done:
	ENDM


	COMMENT	@
/********************************************************************************************

>	void XlongAsr64( const xlong& input, int count, xlong& result)

>	void XlongAsr64One( int count, xlong& result)

	Author: 	Andy
	Created:	29/4/93
	Scope:		Private to XLONG class
	Inputs:		64-bit signed xlong, int shift count
	Outputs:	64-bit signed xlong
	Returns:	none
	Purpose:	Private to ccmath.cpp. Primitive for operator overloading
	Errors:		None (overflow ignored). The shift count is masked with 3F
			for compatibility with normal Intel shifts

********************************************************************************************/


@

	IF	BITS EQ 16

XlongAsr64	PROC USES di cx edx, input:DWORD, count:WORD, result:DWORD

	les	di,input
	mov	eax,es:[di]
	mov	edx,es:[di+4]

	mov	cx,count
	BIGSAR

	les	di,result
	mov	es:[di],eax
	mov	es:[di+4],edx

	ret

XlongAsr64	ENDP


XlongAsr64One	PROC USES di cx edx, count:WORD, result:DWORD

	les	di,result
	mov	eax,es:[di]
	mov	edx,es:[di+4]
	mov	cx,count
	BIGSAR
	mov	es:[di],eax
	mov	es:[di+4],edx
	ret

XlongAsr64One	ENDP

	ELSE

;32-bit
XlongAsr64	PROC USES edi ecx edx, input:DWORD, count:CINT, result:DWORD

	mov	edi,input
	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	ecx,count
	BIGSAR

	mov	edi,result
	mov	[edi],eax
	mov	[edi+4],edx

	ret

XlongAsr64	ENDP


;32-bit
XlongAsr64One	PROC USES edi ecx edx, count:CINT, result:DWORD

	mov	edi,result
	mov	eax,[edi]
	mov	edx,[edi+4]
	mov	ecx,count
	BIGSAR
	mov	[edi],eax
	mov	[edi+4],edx
	ret

XlongAsr64One	ENDP

	ENDIF


	COMMENT	@
/********************************************************************************************

>	int XlongCmp..( const xlong& first, const xlong& second)

	.. = comparison operator, one of:
	GT	>
	GE	>=
	LT	<
	LE	<=
	EQ	==
	NE	!=

	Author: 	Andy
	Created:	29/4/93
	Scope:		Private to XLONG class
	Inputs:		two xlongs
	Outputs:	returns 1 if comparison true, else 0
	Returns:	none
	Purpose:	Private to ccmath.cpp. Primitive for operator overloading
	Errors:		None

********************************************************************************************/
@

;	As the code for these is all so similar, they are built using this macro:
;	Name = postfix e.g. GT, Signed=signed comparison, Unsigned=unsigned comparison

XLONGCMP	MACRO	Name,Signed,Unsigned

	IF	BITS EQ 16
XlongCmp&Name&	PROC	USES di edx, first:DWORD, second:DWORD

	les	di,first
	mov	eax,es:[di]
	mov	edx,es:[di+4]

	les	di,second
	cmp	edx,es:[di+4]				; check top32 first
	jne	@F
	cmp	eax,es:[di]				; check low32
	set&Unsigned&	al					; unsigned cmp
	and	ax,1
	ret

@@:	set&Signed&	al					; signed cmp
	and	ax,1
	ret

XlongCmp&Name&	ENDP

	ELSE
;32-bit
XlongCmp&Name&	PROC	USES edi edx, first:DWORD, second:DWORD

	mov	edi,first
	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,second
	cmp	edx,[edi+4]				; check top32 first
	jne	@F
	cmp	eax,[edi]				; check low32
	set&Unsigned&	al				; unsigned cmp
	and	eax,1
	ret

@@:	set&Signed&	al				; signed cmp
	and	eax,1
	ret

XlongCmp&Name&	ENDP
	ENDIF

	ENDM

; now generate those comparisons

	XLONGCMP	GT,g,a
	XLONGCMP	GE,ge,ae
	XLONGCMP	LT,l,b
	XLONGCMP	LE,le,be
	XLONGCMP	EQ,e,e
	XLONGCMP	NE,ne,ne



	COMMENT	@
/********************************************************************************************

>	void XlongIncrement( xlong& input )

	Author: 	Andy
	Created:	29/4/93
	Scope:		Private to XLONG class
	Inputs:		64-bit signed xlong
	Outputs:	64-bit signed xlong
	Returns:	none
	Purpose:	Private to ccmath.cpp. Primitive for operator overloading. This is
			much more efficient than calling Add with a 1 as a second parameter.
	Errors:		None (overflow ignored).

********************************************************************************************/
@

	IF	BITS EQ 16

XlongIncrement	PROC USES di, input:DWORD

	les	di,input
	inc	DWORD PTR es:[di]
	jz	@F
	ret
@@:	inc	DWORD PTR es:[di+4]
	ret

XlongIncrement	ENDP

	ELSE
;32-bit
XlongIncrement	PROC USES edi, input:DWORD

	mov	edi,input
	inc	DWORD PTR [edi]
	jz	@F
	ret
@@:	inc	DWORD PTR [edi+4]
	ret

XlongIncrement	ENDP

	ENDIF

	IF	0
/********************************************************************************************

>	void XlongDecrement( xlong& input )

	Author: 	Andy
	Created:	29/4/93
	Scope:		Private to XLONG class
	Inputs:		64-bit signed xlong
	Outputs:	64-bit signed xlong
	Returns:	none
	Purpose:	Private to ccmath.cpp. Primitive for operator overloading. This is
			much more efficient than calling Sub with a 1 as a second parameter.
	Errors:		None (underflow ignored).

********************************************************************************************/
	ENDIF

	IF	BITS EQ 16

XlongDecrement	PROC USES di, input:DWORD

	les	di,input
	mov	eax,1
	sub	DWORD PTR es:[di],eax			; DEC wont set carry
	jc	@F
	ret						; common case of no underflow
@@:	dec	DWORD PTR es:[di+4]
	ret

XlongDecrement	ENDP

	ELSE
;32-bit
XlongDecrement	PROC USES edi, input:DWORD

	mov	edi,input
	mov	eax,1
	sub	DWORD PTR [edi],eax			; DEC wont set carry
	jc	@F
	ret						; common case of no underflow
@@:	dec	DWORD PTR [edi+4]
	ret

XlongDecrement	ENDP

	ENDIF

;--------------------------------------------------------------------------------------------
; 64-bit Division Routine
;--------------------------------------------------------------------------------------------
; in: edx:eax and ecx:ebx
; out: edx:eax = edx:eax/ecx:ebx, ecx:ebx=remainder
; (I'm not terribly proud of the efficiency of this code, but it should work)
; (it spends most of its time shifting nothing)

BigDiv	PROC NEAR PRIVATE
	LOCAL	result[2]:DWORD

	xor	edi,edi
	mov	result,edi
	mov	result+4,edi				; zero result to start

; calculate sign of results
	mov	edi,edx
	xor	edi,ecx					; edi=XOR of both sign bits
; make both input args positive
	or	edx,edx
	jns	@F
	Neg64	edx,eax,esi
@@:
	or	ecx,ecx
	jns	@F
	Neg64	ecx,ebx,esi
@@:

	mov	esi,ecx					; ecx better stored in esi

; find first bit set from bit 63 down and shift the divisor left by that amount
	bsr	ecx,esi					; ecx=bit set in divisor
	jnz	@F
	bsr	ecx,ebx
	jz	BigDivZero
	sub	cx,32
@@:	add	cx,32
; cx is the bit number of the higest set bit
; shift the divisor by 63-that value
	sub	cx,63
	neg	cx
	jz	@F					; if no shift needed, do nothing

	xchg	esi,edx
	xchg	ebx,eax

	push	cx
	BIGASL						; shift that divisor
	pop	cx

	xchg	esi,edx
	xchg	ebx,eax

@@:

divlp:	sal	DWORD PTR result,1
	rcl	DWORD PTR result+4,1			; shift result left by 1

	cmp	edx,esi					; compare high words
	jc	restdiv					; jump if next bit of result is 0
	jnz	@F
	cmp	eax,ebx					; compare low words
	jc	restdiv

@@:	or 	BYTE PTR result,1			; put 1 bit in result

	sub	eax,ebx
	sbb	edx,esi					; reduce dividend

restdiv:
	shr	esi,1					; shift the divisor
	rcr	ebx,1

	dec	cx
	jns	divlp					; do all the bits

; finished, now extract results

	mov	ebx,result
	mov	ecx,result+4

	xchg	ebx,eax
	xchg	ecx,edx

; correct final signs
	or	edi,edi
	js	@F
	ret
@@:	Neg64	edx,eax,esi				; change signs of result
	Neg64	ecx,ebx,esi				; and remainder
	ret

BigDivZero:
	xor	al,al
	div	al
	ret

BigDiv	ENDP


	IF	0
/********************************************************************************************

>	void XDiv64( xlong& top, xlong& bottom, xlong& result )

>	void XDiv64One( xlong &bottom, xlong &result)

	Author: 	Andy
	Created:	30/4/93
	Scope:		Private to XLONG class
	Inputs:		two 64-bit signed xlong
	Outputs:	64-bit signed xlong
	Returns:	none
	Purpose:	Private to ccmath.cpp. Primitive for operator overloading.
	Errors:		None (underflow ignored). Div0 will take exception

********************************************************************************************/
	ENDIF

	IF	BITS EQ 16

XDiv64	PROC USES edi esi ebx ecx, top:DWORD, bottom:DWORD, result:DWORD

	les	di,top
	mov	eax,es:[di]
	mov	edx,es:[di+4]

	les	di,bottom
	mov	ebx,es:[di]
	mov	ecx,es:[di+4]

	call	BigDiv

	les	di,result
	mov	es:[di],eax
	mov	es:[di+4],edx

	ret

XDiv64	ENDP


XDiv64One	PROC USES edi esi ebx ecx, bottom:DWORD, result:DWORD

	les	di,result
	mov	eax,es:[di]
	mov	edx,es:[di+4]

	les	di,bottom
	mov	ebx,es:[di]
	mov	ecx,es:[di+4]

	call	BigDiv

	les	di,result
	mov	es:[di],eax
	mov	es:[di+4],edx

	ret

XDiv64One	ENDP

	ELSE

;32-bit
XDiv64	PROC USES edi esi ebx ecx, top:DWORD, bottom:DWORD, result:DWORD

	mov	edi,top
	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,bottom
	mov	ebx,[edi]
	mov	ecx,[edi+4]

	call	BigDiv

	mov	edi,result
	mov	[edi],eax
	mov	[edi+4],edx

	ret

XDiv64	ENDP

;32-bit
XDiv64One	PROC USES edi esi ebx ecx, bottom:DWORD, result:DWORD

	mov	edi,result
	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,bottom
	mov	ebx,[edi]
	mov	ecx,[edi+4]

	call	BigDiv

	mov	edi,result
	mov	[edi],eax
	mov	[edi+4],edx

	ret

XDiv64One	ENDP

	ENDIF

	.FARDATA


tens_table	QWORD	1000000000000000000		; 10^18
	QWORD	100000000000000000
	QWORD	10000000000000000
	QWORD	1000000000000000
	QWORD	100000000000000
	QWORD	10000000000000
	QWORD	1000000000000
	QWORD	100000000000
	QWORD	10000000000
	QWORD	1000000000
	QWORD	100000000
	QWORD	10000000
	QWORD	1000000
	QWORD	100000
	QWORD	10000
	QWORD	1000
	QWORD	100
	QWORD	10					; 10^1

	.CODE

; macro to convert xlong into numeric string. Its a macro so can be used for both ASCII
; and Unicode formats. The only parameter is the opcode used to store ax - for ASCII
; this is stosb, for Unicode it is stosw.

; input: edx:eax=xlong, es:di=destination, ds:si=tens table ptr of xwords
; output: none, uses all regs

; the largest xlong value is 9223372036854780000 approx (19 digits)

; a flag is used to suppress leading zeroes

; (this macro requires a local label called tempbx which is of type WORD)

XLONGTOSTRING	MACRO	dochar_opcode
	LOCAL	toobig,nextten,skipdigit

; first do the '-' sign if it is negative

	or	edx,edx
	jns	@F

	mov	ebx,eax					; save arg.low

	mov	ax,'-'
	dochar_opcode

	mov	eax,ebx					; restore arg.low

	Neg64	edx,eax,ebx

@@:	mov	bx,18					; 19 digits so loop 18 times=bl
							; bh=zero until a character is output

nextten:

	mov	tempbx,bx				; save counter & flags (no regs left!)

; extract next power of ten from table
	mov	ebx,[xsi]
	mov	ecx,[xsi+4]
	add	xsi,8

	push	esi					;save table ptr

; is the number greater than that power of ten?
	
	xor	xsi,xsi					;assume zero result

@@:	cmp	edx,ecx
	jb	toobig
	cmp	eax,ebx
	jb	toobig

; OK, use repeated subtraction to divide by this number
	sub	eax,ebx
	sbb	edx,ecx
	inc	xsi					;inc result
	jmp	short @B

toobig:
	mov	bx,tempbx				; restore counter & flags
	or	bh,bh
	jnz	@F					; we have output some, so output more
	or	xsi,xsi
	jz	skipdigit				; output none, and none yet so skip
	inc	bh					; set 'we have output something' flag

@@:	xchg	esi,eax					; esi=value, eax=result of div
	add	ax,'0'
	dochar_opcode
	mov	eax,esi					; restore result

skipdigit:
	pop	esi					; restore table ptr
	dec	bl
	jnz	nextten

; we always output the final digit
	add	ax,'0'
	dochar_opcode

; result is always zero terminated
	xor	ax,ax
	dochar_opcode

	ENDM



	IF	0
/********************************************************************************************

>	void XlongToAscii( const xlong& arg, LPSTR dest )

>	void XlongToUnicode( const xlong& arg, LPWORD dest )

	Author: 	Andy
	Created:	5/5/93
	Scope:		Private to XLONG class
	Inputs:		64-bit signed xlong
	Outputs:	ASCII string, optional - sign then up to 20 digits, then null byte
	Returns:	none
	Purpose:	Display xlongs in meaningful format
	Errors:		None

********************************************************************************************/
	ENDIF

	IF	BITS EQ 16

XlongToAscii	PROC USES edi esi ebx ecx edx ds, arg:DWORD, dest:DWORD
	LOCAL	tempbx:WORD

	les	di,arg
	mov	eax,es:[di]
	mov	edx,es:[di+4]

	les	di,dest				; we use STOSx so must be es:di

	mov	si,OFFSET tens_table
	mov	bx,SEG tens_table
	mov	ds,bx

	XLONGTOSTRING	stosb

	ret

XlongToAscii	ENDP


XlongToUnicode	PROC USES edi esi ebx ecx edx ds, arg:DWORD, dest:DWORD
	LOCAL	tempbx:WORD

	les	di,arg
	mov	eax,es:[di]
	mov	edx,es:[di+4]

	les	di,dest				; we use STOSx so must be es:di

	mov	si,OFFSET tens_table
	mov	bx,SEG tens_table
	mov	ds,bx

	XLONGTOSTRING	stosw

	ret

XlongToUnicode	ENDP

	ELSE

;32-bit
XlongToAscii	PROC USES edi esi ebx ecx edx, arg:DWORD, dest:DWORD
	LOCAL	tempbx:WORD

	mov	edi,arg
	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,dest				; we use STOSx so must be es:di
; Note: assumes es=ds in flat memory model, which it surely must do

	mov	esi,OFFSET tens_table

	XLONGTOSTRING	stosb

	ret

XlongToAscii	ENDP

;32-bit
XlongToUnicode	PROC USES edi esi ebx ecx edx, arg:DWORD, dest:DWORD
	LOCAL	tempbx:WORD

	mov	edi,arg
	mov	eax,[edi]
	mov	edx,[edi+4]

	mov	edi,dest				; we use STOSx so must be es:di

	mov	esi,OFFSET tens_table

	XLONGTOSTRING	stosw

	ret

XlongToUnicode	ENDP

	ENDIF

	IF	0
/********************************************************************************************

>	XLONG XMatrixCalc( FIXED16 fix1, XLONG l1, FIXED16 fix2, XLONG l2, XLONG& result)

	Author: 	Andy
	Created:	30/5/93
	Scope:		Private to XLONG class
	Inputs:		two FIXED16s, two xlongs
	Outputs:	Result returns modified. (32-bit version is a macro).
	Returns:	XLONG result of fix1*l1 + fix2*l2
	Purpose:	Matrix multiply primitive done using intermediate 128-bit results
			so full accuracy is maintained. Special cases are when fix1 or fix2
			are 0.0 or 1.0 as multiplications may be avoided (NOT YET IMPLEMENTED)
			Note that the result is rounded to the nearest integer.
	Errors:		None (overflow ignored).

********************************************************************************************/
	ENDIF


XMatrixCalc	PROC	USES ebx ecx esi edi, fix1:FIXED16, l1:DWORD, fix2:FIXED16, l2:DWORD, res:DWORD

	LOCAL	result[4]:LONG			; we really don't have enough registers here!

	mov	eax,fix1
	cdq					; edx:eax=fix1
	IF	BITS EQ 16
	les	di,l1
	mov	ebx,es:[di]
	mov	ecx,es:[di+4]			; ecx:ebx=l1
	ELSE
	mov	edi,l1
	mov	ebx,[edi]
	mov	ecx,[edi+4]
	ENDIF

	call	MulHuge				; 128-bit result

	mov	result,eax
	mov	result+4,edx
	mov	result+8,ebx
	mov	result+12,ecx

	mov	eax,fix2
	cdq					; edx:eax=fix2
	IF	BITS EQ 16
	les	di,l2
	mov	ebx,es:[di]
	mov	ecx,es:[di+4]			; ecx:ebx=l2
	ELSE
	mov	edi,l2
	mov	ebx,[edi]
	mov	ecx,[edi+4]
	ENDIF

	call	MulHuge				; 128-bit result

; now do a 128-bit addition
; round to nearest int by adding "0.5" before the shift down
	add	eax,8000h
	adc	edx,0
	adc	ebx,0
	adc	ecx,0

	add	result,eax
	adc	result+4,edx
	adc	result+8,ebx
	adc	result+12,ecx

; result is in fixed format, so need shift right by 16 for long result
; easiest way is to re-load from memory with different alignment
	mov	eax,result+2
	mov	edx,result+2+4

	IF	BITS EQ 16
	les	di,res
	mov	LONG PTR es:[di],eax
	mov	LONG PTR es:[di+4],edx
	mov	ax,di				; 16-bit caller wants a ptr result in dx:ax
	mov	dx,es
	ELSE
; 32-bit caller can take 64-bit results in edx:eax, so this should be done at some point.
	mov	edi,res
	mov	[edi],eax
	mov	[edi+4],edx
	mov	edi,eax				; return result ptr in eax
	ENDIF

	ret

XMatrixCalc	ENDP


	IF	0
/********************************************************************************************

>	void XlongByFixed16One( XLONG* x1, FIXED16 fix)

	Author: 	Andy
	Created:	30/5/93
	Inputs:		An XLONG (which will be modified) and a FIXED16.
	Outputs:	None
	Returns:	XLONG result of x1 * fix
	Purpose:	Multiplying without losing precision. Private function used by
			operator overloading on *=.
	Errors:		None (overflow ignored).
	Scope:		Private

********************************************************************************************/
	ENDIF

XlongByFixed16One	PROC	USES ebx ecx edx esi edi, x1:DWORD, fix:FIXED16

	mov	eax,fix
	cdq					; edx:eax=one arg

	IF	BITS EQ 16
	les	di,x1				; get ptr to input arg
	mov	ebx,es:[di]
	mov	ecx,es:[di+4]			; get other arg
	ELSE
	mov	edi,x1
	mov	ebx,[edi]
	mov	ecx,[edi+4]
	ENDIF

	call	MulHuge

; result needs shifting right by 16-bits
; currently	112233445566778899AABBCCDDEEFFGG
;		ecx     ebx     edx     eax
; wanted	778899AABBCCDDEE
;		edx     eax
; i.e. new edx=(ebx<<16)|(old edx>>16)
;      new eax=(old edx<<16)|(old eax>>16)

	mov	ecx,edx				; ecx=old edx

	shr	eax,16
	shl	ecx,16
	or	eax,ecx				; eax=done

	shr	edx,16				; old edx>>16
	shl	ebx,16
	or	edx,ebx

	IF	BITS EQ 16
	les	di,x1
	mov	es:[di],eax
	mov	es:[di+4],edx
	ELSE
	mov	edi,x1
	mov	[edi],eax
	mov	[edi+4],edx
	ENDIF

	ret

XlongByFixed16One	ENDP



	IF	0
/********************************************************************************************

>	double XlongToDouble( const XLONG& x )

	Author: 	Andy
	Created:	10/6/93
	Inputs:		An XLONG
	Outputs:	None
	Returns:	A double-precision value
	Purpose:	Conversion between types. Private to ccmaths.h which has a better
			interface on top of this.
	Errors:		None (overflow impossible, some precision may be lost)
	Scope:		Private

********************************************************************************************/
	ENDIF

XlongToDouble	PROC	USES xdi, x:DWORD

	DS_PROLOG

	IF	BITS EQ 16
	les	di,x
	fild	QWORD PTR es:[di]
	ELSE
	mov	edi,x
	fild	QWORD PTR [edi]
	ENDIF

	RETURNDOUBLE
	fwait

	DS_EPILOG
	ret

XlongToDouble	ENDP

	IF	0
/********************************************************************************************

>	void DoubleToXlong( const double, XLONG& )

	Author: 	Andy
	Created:	10/6/93
	Inputs:		A double for conversion and a reference to an xlong (for the return
			value).
	Outputs:	XLONG reference is updated with new value
	Returns:	None
	Purpose:	Conversion between types. Private to ccmaths.h which has a better
			interface on top of this.
	Errors:		None (overflow ignored). No rounding. (I think).
	Scope:		Private

********************************************************************************************/
 	ENDIF

DoubleToXlong	PROC	USES xdi, arg:DOUBLE, x:DWORD

	IF	BITS EQ 16
	les	di,x				; get address of result
	fld	arg				; push double on FPU stack
	fistp	QWORD PTR es:[di]		; convert to 64-bit integer
	fwait
	ELSE
	mov	edi,x
	fld	arg
	fistp	QWORD PTR [edi]
	fwait
	ENDIF
	ret

DoubleToXlong	ENDP

	END
