#pragma once

#include "sdkddkver.h"

// Win32 doesn't need any source changes - its done by the linker
#define CAMAPI
#define CCAPI

#define nobreak		// extension for the C case statement
#define OVERRIDE override
#define FINAL final

// This file includes the required system headers and defines types whose definitions
// are machine-dependent. It should also include other machine-specific header files.

#define	STRICT	1

// Modify the following defines if you have to target a platform prior to the ones specified below.
// Refer to MSDN for the latest info on corresponding values for different platforms.

// _MSC_VER

#ifndef WINVER
#define WINVER			_WIN32_WINNT_VISTA
#endif

#ifndef _WIN32_WINNT
#define _WIN32_WINNT	_WIN32_WINNT_VISTA
#endif

#ifndef _WIN32_WINDOWS
#define _WIN32_WINDOWS	_WIN32_WINNT_VISTA
#endif

#ifndef _WIN32_IE
#define _WIN32_IE		_WIN32_IE_IE60		// Internet Explorer 6.0 (coming with XP)
#endif

#define _CRTDBG_MAP_ALLOC	// Enables memory leak detection for malloc/free

#include <sys\utime.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <wchar.h>

#include <stdlib.h>
#include <crtdbg.h>

#define OEMRESOURCE			// required for access to the display driver's bitmaps

#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions

#include <afxole.h>         // MFC OLE classes
#include <afxodlgs.h>       // MFC OLE dialog classes

#include <afxdisp.h>        // MFC Automation classes
#include <afxmt.h>

#include <intrin.h>

//#include "skinlib.h"		// Skinning library
//#include <varstr.h>

#ifndef _INC_WINDOWS
#include <windows.h>
#endif

#ifndef _INC_WINDOWSX
#include <windowsx.h>
#endif


#include <stdlib.h>

// if _OLE_VER is defined, leave it alone
#ifndef _OLE_VER
	#define _OLE_VER 0x200
#endif

#if _OLE_VER > 0
#include <afxole.h>			// MFC OLE support (unless OLE_VER is zero)
#endif

#if (_OLE_VER >= 0x200)
  #include <afxodlgs.h>
  #include <afxdisp.h>
#endif

#include <GdiPlus.h>

#pragma warning(disable: 4505)	// Suppress 'unreferenced local function has been removed'
#pragma warning(disable: 4514)	// Suppress 'unreferenced inline function has been removed'
#pragma warning(disable: 4710)	// Suppress '... function not inlined'

// Treat following warnings as error
#pragma warning (error: 4715)	// 'warning: not all control paths return a value'


// Inside the STL we set warning level 3 and disable some selected warnings, so that we are 
// not hassled by things we cannot fix
// See also: http://digipen1.xmmg.com:8181/dpweb/docs/CompilingWarningLevel4.html
#pragma warning(push, 3)		// Set warning levels to a quieter level for the STL
#pragma warning(disable: 4290)	// Suppress 'C++ Exception Specification ignored'
#pragma warning(disable: 4786)	// Suppress '... truncated to 255 chars in debug'
#pragma warning(disable: 4510)	// Suppress '... default constructor could not be generated'
#pragma warning(disable: 4610)	// Suppress '... can never be instantiated - user defined constructor required'
#pragma warning(disable: 4127)	// Suppress 'conditional expression is constant'

#include <vector>
#include <string>
#include <memory>
#include <functional>
#include <list>
#include <map>
#include <algorithm>
#pragma warning(pop)			// Restore warning levels for our code

// Why this isn't standard I don't know...
namespace std
{
#if defined(_UNICODE)
	typedef wstring		tstring;
#else
	typedef string		tstring;
#endif
};

// Useful generic std-based typedefs
typedef std::vector<std::tstring> tstringVector;

typedef unsigned long ULONG;

#ifdef _DEBUG
  BOOL CCAPI IsUserName(const char *wanted);
#else
  #define	IsUserName(name)	FALSE
#endif

// Custom BITMAPINFOHEADER compression values
const int BI_XARA_ARGB = 1000; // For 32 bit bitmaps indicates that top byte is alpha channel

// In GDraw 2.008 Docs it says that 32 bit BMPs need this setting to this value
// if they are to use the Transparency channel. (GDraw_SetDIBitmap)
const DWORD BI_GDRAW_BGRT = 0x80000001;

//#include "mathutil.h"
//#include "BaseDlg.h"

#define UNREFERENCED_LOCAL_VARIABLE(V)	(void)(V)
