#pragma once

#include <string>

class CTTCFontInfo
{
public:
	CTTCFontInfo() : weight(400), italic(false), offset(0) {}
	void Decompose(std::wstring str);
	std::wstring fontNameOriginal;
	std::wstring fontName;
	int weight;
	bool italic;
	DWORD offset;
};

class CTTCManager
{
public:
	static size_t GetTTCFontProps(TCHAR* pszFilename, std::vector<CTTCFontInfo>& info);
	static size_t GetTTCFontProps(CCFile* pFile, std::vector<CTTCFontInfo>& info);
	static bool ExtractTTFFromTTC(TCHAR* pszTTC, TCHAR* pszTTF, unsigned long offset);
	static bool ExtractTTFFromTTC(CCFile* pIn, CCFile* pOut, unsigned long offset);
	static int TTCMatchFontProperties(std::vector<CTTCFontInfo>& info, std::wstring strFontName, int weight, bool italic);
};