#pragma once

class CharSet: public std::vector<unsigned char>
{
public:

	void Init(size_t size = 8 * 1024)
	{
		resize(size, 0);
	}

	void Add(unsigned int charCode)
	{
		if (size() == 0)
			Init();
		if (!Exists(charCode))
			m_cnt++;

		(*this)[charCode / 8] |= (1 << (charCode % 8));

#ifdef _DEBUG
		m_subset.insert((WCHAR)charCode);
#endif
	}

	void AddLatin()
	{
		for (UINT i = ' '; i <= '~'; i++)
			Add(i);
	}

	size_t Count() const 
	{
#ifdef _DEBUG
		_ASSERT(m_subset.size() == m_cnt);
#endif
		return m_cnt;
	}

	bool Exists(unsigned int charCode) const
	{
		return 0 != ((*this)[charCode / 8] & (1 << (charCode % 8)));
	}
private:
	size_t m_cnt = 0;
#ifdef _DEBUG
	std::set<WCHAR> m_subset; // for debug purposes only - it's handy to see all the subset numbers at once
#endif
};
